package net.kldp.cats;

import net.kldp.cats.core.*;
import net.kldp.cats.ui.*;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedList;

import javax.swing.JFrame;
import javax.swing.SwingUtilities;

/**
 *  ڵ зϴ ý
 * (ܼȯ ׷ȯ     ִ.)
 * 
 * ǻ.
 * Ŭ͸   ݸα׷    ʰ  ư.
 * 
 * @author sjkim
 * 
 * @history 2006-08 
 * @history 2006-08-17
 * @history 2006-08-21
 * @history 2006-08-27 runGroupingW ޼ҵ ߰
 * @history 2006-09-03 runGrouping ޼ҵ 
 */
public class cats {

  public static Hashtable commandHash = new Hashtable();
  
  /**
   * @param args
   * @throws Exception 
   */
  public static void main(String[] args) throws Exception {
    if (0 == args.length) {
      SwingUtilities.invokeLater(new Runnable(){
        public void run() {
          MainFrame mainFrame = new MainFrame();
          mainFrame.setVisible(true);          
          redirectionOutput(mainFrame);
          initCommandHash();
        }
      });
    }
  } 
  
  private static void redirectionOutput(MainFrame main) {
    System.setOut(new PrintStream(
        new ConsoleOutputStream(main.getTaOutput(), System.out),
                                true));
    System.setErr(new PrintStream(
        new ConsoleOutputStream(main.getTaOutput(), System.err),
                                true));
  }
  
  private static void initCommandHash() {
    commandHash.put("histo", new ColorHistogram());
    commandHash.put("cor", new Correlogram());
    commandHash.put("hrShort", new ShortHierarchicalClustering());
    commandHash.put("hrLong", new LongHierarchicalClustering());
    commandHash.put("hrMean", new MSTClustering());
    commandHash.put("ptKmeans", new KMeansClustering());
    commandHash.put("ptForgy", new ForgyClustering());
    commandHash.put("seq", new SequentialClustering());
  }
  
  /**
   * 絵   ¸ ش.
   * ǻ.
   * α׷  ü  ؾ ȭ鿡 Ÿ.
   * 
   * @param args
   * 
   * @history 2006-08-26 
   * @history 2006-09-01 з ٷ   ʰ ȭ鿡 ش.
   * @history 2006-09-03 Ķ  
   */
  public static void runGroupingW(MainFrame main) {
    String[] args = main.getArguments();
    String[] param;
    for (int i = 0; i < args.length; i++) {
      System.out.print(args[i] + ", ");
    }
    System.out.println();
    if (6 == args.length || 8 == args.length) {
      if (isIllegalArguments(args)) {
        return;
      }
      try {
        ImageFeaturing featuring = null;
        ImageClustering grouping = null;
        File f = new File(args[0]);
        String groupingCommand, groupNum;
        String lstFile = f.getName() + ".lst";
        String cmpFile = f.getName() + "-" + args[4] + ".cmp";
        String grpFile = f.getName() + "-" + args[2] + "-" + args[4] + ".grp";
        
        System.out.println(" Ʈ ϴ.");
        if (!makeFileList(args[0], f.getName() + ".lst")) {
          return;
        }
        
        System.out.println("絵 մϴ.");
        featuring = (ImageFeaturing) commandHash.get(args[4]);
        final LongTask task = (LongTask) featuring;
        final Component comp = main;
        SwingUtilities.invokeLater(new Runnable(){
          public void run() {
            ProgressDisplay progressDisplay =
              new ProgressDisplay(comp, "絵 մϴ. " +
                  "ø ٷ ּ.", task);
            progressDisplay.show(); 
          }
        });
        featuring.read(lstFile);
        if (8 == args.length) {
          featuring.compute(Integer.parseInt(args[5]),
              Integer.parseInt(args[6]), Integer.parseInt(args[7]));
        } else {
          featuring.compute(Integer.parseInt(args[5]));
        }
        featuring.write(cmpFile);

        System.out.println(" зմϴ.");
        grouping = (ImageClustering) commandHash.get(args[2]);
        grouping.read(cmpFile);
        grouping.compute(Integer.parseInt(args[3]));
        grouping.write(grpFile);

        System.out.println("з  ݴϴ.");
        main.showResult();        
      } catch (Exception e) {
        e.printStackTrace();
      }
    }
  }
  
  /**
   * ƱԸƮ  ȮѴ.
   * @param args
   * @return ƱԸƮ  Ʋ     ȯѴ.
   * @history 2006-09-03
   */
  public static boolean isIllegalArguments(String[] args) {
    File srcDir, dstDir;
    String grouping, groupNum;
    srcDir = new File(args[0]);
    dstDir = new File(args[1]);
    if (!srcDir.isDirectory()) {
      System.err.println(args[0] + " 丮 ƴմϴ.");
      return true;
    }
    if (!dstDir.isDirectory()) {
      System.err.println(args[1] + " 丮 ƴմϴ.");
      return true;
    }
    if (null == commandHash.get(args[2])) {
      System.err.println(args[2] + " з  ϼ.");
      return true;
    }
    try {
      Integer.parseInt(args[3]);
    } catch (NumberFormatException n) {
      System.err.println(args[3] + " ׷    ԷϿϴ.");
      return true;
    }
    if (null == commandHash.get(args[4])) {
      System.err.println(args[4] + " 絵   ϼ.");
      return true;
    }
    try {
      Integer.parseInt(args[5]);
    } catch (NumberFormatException n) {
      System.err.println(args[5] + "  Էϼ.");
      return true;
    }
    if (8 == args.length) {
      try {
        Integer.parseInt(args[6]);
        Integer.parseInt(args[7]);
      } catch (NumberFormatException n) {
        System.err.println(args[6] + ", " + args[7] + "  Էϼ.");
        return true;
      }
    }

    return false;
  }

  /*
  public static boolean isIllegalArguments(String[] args) {
    File srcDir, dstDir;
    String grouping, groupNum;
    srcDir = new File(args[0]);
    dstDir = new File(args[1]);
    if (!srcDir.isDirectory()) {
      System.err.println(args[0] + " 丮 ƴմϴ.");
      return true;
    }
    if (!dstDir.isDirectory()) {
      System.err.println(args[1] + " 丮 ƴմϴ.");
      return true;
    }
    if (null == commandHash.get(args[2])) {
      System.err.println(args[2] + " 絵   ϼ.");
      return true;
    }
    try {
      Integer.parseInt(args[3]);
    } catch (NumberFormatException n) {
      System.err.println(args[5] + "  Էϼ.");
      return true;
    }    
    if (args[2].equals("cor")) {
      try {
        Integer.parseInt(args[4]);
        Integer.parseInt(args[5]);
      } catch (NumberFormatException n) {
        System.err.println(args[4] + "," + args[5] + "  Էϼ.");
        return true;
      }
      grouping = args[6];
      groupNum = args[7];
    } else {
      grouping = args[4];
      groupNum = args[5];
    }
    if (null == commandHash.get(grouping)) {
      return true;
    }

    try {
      Integer.parseInt(groupNum);
    } catch (NumberFormatException n) {
      System.err.println(groupNum + "  Էϼ.");
      return true;
    }
    return false;
  } */

  /**
   * 
   * @param args
   * @return
   * @history 2006-08-17
   */
  public static boolean checkArguments(String[] args) {
    File srcDir, dstDir;
    srcDir = new File(args[0]);
    dstDir = new File(args[1]);
    if (!srcDir.isDirectory()) {
      System.err.println(args[0] + " 丮 ƴմϴ.");
      return true;
    }
    if (!dstDir.isDirectory()) {
      System.err.println(args[1] + " 丮 ƴմϴ.");
      return true;
    }
    if (!(args[2].equals("histo") || args[2].equals("cor"))) {
      System.err.println(args[2] + " 絵   ϼ.");
      return true;
    }
    if (!(args[4].equals("kmeans") || args[4].equals("mst"))) {
      System.err.println(args[4] + " з  ϼ.");
      return true;
    }
    try {
      Integer.parseInt(args[5]);
    } catch (NumberFormatException n) {
      System.err.println(args[5] + "  Էϼ.");
      return true;
    }
    return false;
  }

  
  /**
   * ܼ 
   * @param args
   * @throws Exception
   * @history 2006-08-07  
   * @deprecated 2006-08-17
   */
  public static void run(String[] args) throws Exception {
    String[] param;
    if (5 == args.length) {
      if (checkError(args)) {
        return;
      }
      File f = new File(args[0]);
      if (!makeFileList(args[0], f.getName() + ".lst")) {
        return;
      }
      param = new String[2];
      if (args[2].equals("histo")) {
        param[0] = f.getName() + ".lst";
        param[1] = f.getName() + "-" + args[2] + ".cmp";
        Histogram.main(param);
      } else if (args[2].equals("cor")) {
        param[0] = f.getName() + ".lst";
        param[1] = f.getName() + "-" + args[2] + ".cmp";
        correlogram_test.main(param);
      }
      if (args[3].equals("kmeans")) { 
        Kmeans km = new Kmeans(".",
            f.getName() + "-" + args[2] + ".cmp",
            f.getName() + "-" + args[3] + "-" + args[2] + ".grp",
            Integer.parseInt(args[4]));
      } else if (args[3].equals("mst")) {
        param = new String[3];
        param[0] = args[4];
        param[1] = f.getName() + "-" + args[2] + ".cmp";
        param[2] = f.getName() + "-" + args[3] + "-" + args[2] + ".grp";
        MST.main(param);
      }
      param = new String[3];
      param[0] = f.getName() + ".lst";
      param[1] = f.getName() + "-" + args[3] + "-" + args[2] + ".grp";
      param[2] = args[1];
      MovePictures.main(param);
    } else {
      System.out.println(" : java pcats [ 丮] [ű 丮]" +
          "[絵  = histo, cor] [з  = kmeans, mst] [׷ ]");
    }    
  }
  
  /**
   * 
   * @param args
   * @return
   * @deprecated 2006-08-17
   */
  public static boolean checkError(String[] args) {
    File srcDir, dstDir;
    srcDir = new File(args[0]);
    dstDir = new File(args[1]);
    if (!srcDir.isDirectory()) {
      System.err.println(args[0] + " 丮 ƴմϴ.");
      return true;
    }
    if (!dstDir.isDirectory()) {
      System.err.println(args[1] + " 丮 ƴմϴ.");
      return true;
    }
    if (!(args[2].equals("histo") || args[2].equals("cor"))) {
      System.err.println(args[2] + " 絵   ϼ.");
      return true;
    }
    if (!(args[3].equals("kmeans") || args[3].equals("mst"))) {
      System.err.println(args[3] + " з  ϼ.");
      return true;
    }
    try {
      Integer.parseInt(args[4]);
    } catch (NumberFormatException n) {
      return true;
    }
    return false;
  }
  
  public static boolean makeFileList(String path, String output)
    throws IOException {
    File dir;
    String[] list;
    int count;
    FileWriter fw;
    PrintWriter pw;
    LinkedList nameList;
    Iterator it;
    dir = new File(path);
    list = dir.list();
    if (null != list) {
      fw = new FileWriter(output);
      pw = new PrintWriter(fw);
      nameList = new LinkedList();
      count = 0;
      for (int i = 0; i < list.length; i++) {
        if (list[i].indexOf(".jpg") > -1 ||
            list[i].indexOf(".JPG") > -1) {
          nameList.addLast(dir.getAbsolutePath() +
              File.separator + list[i]);
          count++;
        }
      }
      pw.println(count);
      it = nameList.iterator();
      while (it.hasNext()) {
        pw.println(it.next());
      }
      
      pw.close();
      fw.close();
      return true;
    } else {
      System.err.println("丮 ϴ.");
      return false;
    }
  }

}
