package net.kldp.cats.core;

import java.awt.image.BufferedImage;
import java.io.IOException;

import net.kldp.cats.ui.LongTask;

/**
 *  ̹  о  ̹  絵 ϴ Ŭ
 * 
 * Է  (̹  ̸ Ʈ)
 * n :  ̹  
 * name : ̹  ̸(. p-01-001.jpg)
 * 
 *   ( ̹  絵)
 * #a(Է Ͽ  ) #b(Է Ͽ  ) similarity(0 ~ N)
 * 
 * 絵  0 ~ N. N  ׷  
 * 0   ϴ.
 * 
 * @author sjkim
 * @history 2006-08-26  
 * Histogram Ŭ üѴ.
 */
public class ColorHistogram extends ImageFeaturing
                            implements LongTask {

  protected Quantization quant = null;
  protected int[][] histogramList = null; // 1-based
  protected int current;

  public void compute() {
    compute(64);
  }

  public void compute(int numOfColor) {
    switch (numOfColor) {
      case 8:
        quant = QuantizationFactory.makeSimpleQuantization(2, 2, 2);
        break;
      case 256:
        quant = QuantizationFactory.makeSimpleQuantization(8, 8, 8);
        break;
      default:
        quant = QuantizationFactory.makeSimpleQuantization(4, 4, 4);
    }
    BufferedImage bi;
    histogramList = new int[size + 1][numOfColor];
    current = 0;
    for (int i = 1; i <= size; i++) {
      bi = Util.readImage(fileList[i]);
      getHistogram(bi, histogramList[i]);
      current++;
    }
    for (int i = 1; i < size; i++) {
      for (int j= i + 1; j <= size; j++) {
        simTab[i][j] = Util.compare(histogramList[i], histogramList[j]); 
        simTab[j][i] = simTab[i][j];
      }
    }
  }
  
  /**
   * RGB ÷ ̹ ׷ Ѵ.
   * @param bi RGB ̹
   * @param nColor ȭ 
   * @param histogram ÷ ׷(1 迭)
   */
  private void getHistogram(BufferedImage bi, int[] histogram) {
    int width = bi.getWidth();
    int height = bi.getHeight();
    int[][] red = Util.readData(bi, 0);
    int[][] green = Util.readData(bi, 1);
    int[][] blue = Util.readData(bi, 2);
    for (int i = 0; i < histogram.length; i++) {
      histogram[i] = 0;
    }
    for (int r = 0; r < height; r++) {
      for (int c = 0; c < width; c++) {
        histogram[quant.table[quant.channel1st[red[r][c]]]
                             [quant.channel2nd[green[r][c]]]
                             [quant.channel3rd[blue[r][c]]]
                  ]++;
      }
    }
  }

  public int getCurrent() {
    return current;
  }

  public int getLengthOfTask() {
    return size;
  }

  public boolean isDone() {
    return current == size;
  }

  public String getMessage() {
    return "ü " + size + "   " + current + "    Ͽϴ.";
  }

  public void compute(int Quanted, int DISTANCE, int BAND) {
  }


}
