package net.kldp.cats.core;

import java.awt.image.BufferedImage;
import java.io.IOException;

import net.kldp.cats.ui.LongTask;

/** 
 * ڸα׷ ˰ 
 * @author Lynn
 * @history 2006 8 11
 * @history 2006-08-26 sjkim
 * LongTask ̽ , ڵ , compute ޼ҵ 
 */
public class Correlogram extends ImageFeaturing
                         implements LongTask {

  // int BAND; // band correlogram (0 ̸ band correlogram  ) 
	protected int width;
  protected int height;
	protected static int Quanted_Color; //ȭ ÷ 
	protected double sim = 0; // 絵
	//static int num = 0; // ߺǴ ȼ 

	protected static int data2D[][]; //̹   ϴ 迭 
	protected double correlogramList[][][];//̹ ڸα׷  ϴ 迭

	private BufferedImage bi ;
  
  private int current;
  
  /**
   * @override
   */
  public void read(String fname) throws IOException {
    super.read(fname);
    correlogramList = new double[size + 1][][];
  }

  public void compute() {
    compute(64, 7, 4);
  }
  
  public void compute(int numOfColor) {
    compute(numOfColor, 7, 4);
  }

  /**
   * ڸα׷ ϴ ޼ҵ
   * @param Quanted
	 * @param DISTANCE k  (Ÿ k )
	 * @param BAND ڸα׷ Ķ(k ۰,   )
   * (band = 0ϰ ڸα׷  )
	 */
	public void compute(int Quanted ,int DISTANCE, int BAND) {
    current = 0;
    for(int i = 1; i <= size; i++){
			file2array(i, Quanted);
       //̹ ڸα׷ 
			correlogramList[i] = cal_correlogram(data2D, Quanted, DISTANCE, BAND);
      current++;
    }
    for (int i = 1; i < size; i++) {
      for (int j = i + 1; j <= size; j++) {
        simTab[i][j] = Util.compare(correlogramList[i], correlogramList[j]);
        simTab[j][i] = simTab[i][j];
      }
    }
  }
  
  /**
   * ̹ Ͽ   ȭ ϰ 2 ķ  
	 * 
	 * @param current_order ̹ ȣ
	 * @param Quanted ȭ ÷
	 * 
	 */
	void file2array(int current_order, int Quanted){
    System.out.println(fileList[current_order]);
    // Ʈ ִ  ̸ ޾Ƽ ̹  
    bi = Util.readImage(fileList[current_order]);
    width = bi.getWidth();
    height = bi.getHeight();
    
    int[][] red = Util.readData(bi, 0);
    int[][] green = Util.readData(bi, 1);
    int[][] blue = Util.readData(bi, 2);
    quant_gen(red, green, blue, Quanted);
  }
  
   /**
    * 
    * @param red ̹ red band color 
    * @param green ̹ green band color 
    * @param blue ̹ blue band color 
    * @param q ȭ ÷  (= 8, 64, 512  )
    *  ڰ  ȭ ÷ 64
    */
  void  quant_gen(int red[][],int green[][], int blue[][],int q){
    Quantization quant ;
    if (q == 8) {
			quant = QuantizationFactory.makeSimpleQuantization(2, 2, 2); // 8
    } else if (q == 512) {
			quant= QuantizationFactory.makeSimpleQuantization(8, 8, 8); //512
    } else { 
      quant= QuantizationFactory.makeSimpleQuantization(4, 4, 4); //64
    }
    
    data2D = new int[height][width];
    for (int r = 0; r < height; r++) {
      for (int c = 0; c < width; c++) {
        data2D[r][c] = quant.table[quant.channel1st[red[r][c]]]
                                  [quant.channel1st[green[r][c]]]
                                  [quant.channel1st[blue[r][c]]];
      }
    }
  }
  
  /**
   *  ڸα׷ &  ڸα׷  Ѵ.
   * 
   * @param data2D ̹  (迭)
   * @param Num_Color ȭ   (32,64,128, 256,...)
   * @param distance Ÿ k ( >0 )
   * @param band band-correlogram ( 0̸ band correlogram )
   * @return ImageFeature class object( ̹ ڸα׷  (2D array)
   *  - ڸα׷  ȯ (0   ) )
   */
	double[][] cal_correlogram(int data2D[][], int Num_Color, 
      int distance, int band) {
		if(distance<=0) //Ÿk  0 ϶ ּҰŸ 1 set 
				distance = 1;
		double[][] correlogram_data; //ڸα׷   2 迭 ( [Ÿk][color=64,128,256...]
		if(band!=0){	
			if(band>distance&&band<0) // band distance  ũ band-correlogram    
				band = 1;
			correlogram_data = new double [band][Num_Color]; //data2D  correlogram   2D array  (  x number of color)
		}
		else{ 
			band = distance;
			correlogram_data = new double [band][Num_Color]; //data2D  correlogram   2D array  (distance x number of color)
		}
		int  band_gap = (int)Math.ceil(distance/band );
			int  cor_column_start = 0, cor_column_end = 0;
			int  cor_row_start=0, cor_row_end =0;
			int dis = 1;
			
			for(int D =0; D< band;D++) // Ÿ 1, 3 ,5 7ؿ ó 
			{
				dis = (D+1) * band_gap ;
				
				for(int  Current_Color=0; Current_Color< Num_Color; Current_Color++){	//64  ؼ ó
					 correlogram_data[D][Current_Color] = 0; //    ڸα׷  迭 ʱȭŴ
					 int total_pixel = 1; // ÷ Ÿ dis   ȼ  ϴ  ʱȭ
					 int same_pixel =  0;

					 for(int r = 0 ; r< height; r++){
						cor_row_start = r-dis;
						cor_row_end = r + dis;
						
						for(int c = 0 ; c< width; c++){	
							cor_column_start = c-dis; 
							 cor_column_end = c+dis;
							if(data2D[r][c]==Current_Color) 
							 for(int current_row = cor_row_start; current_row <=cor_row_end; current_row++){
								 if(current_row>=0&&current_row <height) //ȼ ġ  0 ۰ų ̺ ũ  
								 {
									 for(int current_column = cor_column_start; current_column <=cor_column_end; current_column++) 
									 {
										 if(current_column>=0&&current_column <width) //ȼ ġ 0 ۰ų ̺ ũ ȵ
									 
											 if(Math.abs(current_row-r)==dis||Math.abs(current_column-c)==dis){ // (r,c)ȼ dis Ÿŭ  ȼ  Ȯ	 
												 total_pixel++; // Ÿ dis ִ ȼ 1 Ŵ
												 	if(data2D[current_row][current_column]==Current_Color){ // Ÿ dis  ִ ȼ ÷   ȼ  
												 		same_pixel++;//   1ŭ Ŵ
											 	}
											 }
									 }
								 }
							 }
							 					 
						} //end of for(int c; width )
					} //end of for(int r;..
					correlogram_data[D][Current_Color]=(double)same_pixel/total_pixel;
				} //end of for (color)
				
			}//end of for(distance)
			return correlogram_data;
  }
  /**
   * ڸα׷ ̿  ̹ 絵 ϴ ޼ҵ
   * 
   * @param correlogram_data1 ̹1 ڸα׷  , 2 迭 
   * @param correlogram_data2 ̹2  , 2 迭
   * @param Num_Distance ŸK  (k=4 ; 1,3,5,7) 
   * @param Num_Color ȭ    (32,64,128,256,....)
   * @return  ̹   ȯ( 0    ̹)
   *
   * Ÿ: 1,3,5,7 ; : ȭ (64)
   * equation : I = sigma |r-r'| / (r+r'+1) 
   * @deprecated
   */
  double compare(double correlogram_data1[][], double correlogram_data2[][],
      int Num_Distance, int Num_Color) {
    sim = 0.0; //reset
    double I = 0; // |I-I'|
    double a = 0;
    
    for(int D =0; D < Num_Distance ; D++) {
      for(int Current_Color =0; Current_Color< Num_Color; Current_Color++) {
        //I = (Math.abs(correlogram_data1[D][Current_Color]-correlogram_data2[D][Current_Color])) / (correlogram_data1[D][Current_Color]+correlogram_data2[D][Current_Color]+1);
        I = (Math.abs(correlogram_data1[D][Current_Color]-correlogram_data2[D][Current_Color])); //
        a = (correlogram_data1[D][Current_Color]+correlogram_data2[D][Current_Color]+1); //и
        sim+=I/a;
      }
    }
		System.out.println("絵 (0  )=" + sim);
    return sim;
  }
  
  public double write_sim(double result) {
    return result;
  }

  public int getCurrent() { 
    return current;
  }

  public int getLengthOfTask() {
    return size;
  }

  public boolean isDone() {
    return current == size;
  }

  public String getMessage() {
    return "ü " + size + "   " + current +
    "  Ÿ     Ͽϴ.";
  }
}
