package net.kldp.cats.core;

import java.io.*;
import java.awt.Frame;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.awt.image.*;

import net.kldp.cats.ui.LongTask;

/**
 *  ̹  о  ̹  絵 ϴ α׷
 * 
 * Է  (̹  ̸ Ʈ)
 * n :  ̹  
 * name : ̹  ̸(. p-01-001.jpg)
 * 
 *   ( ̹  絵)
 * #a(Է Ͽ  ) #b(Է Ͽ  ) similarity(0 ~ N)
 * 
 * @history 2006-06-25
 * @history 2006-08-06
 * 絵  0 ~ N  ٲ. N  ׷  
 * 0   ϴ.
 * @deprecated 2006-08-26 ColorHistogram  ü
 */
public class Histogram {
  
  public static void main(String[] args) throws Exception {
    System.out.println(" ̹  絵  ");
    if (2 == args.length) {
      Histogram st = new Histogram(args[0], args[1]); // set01.in, set01.out
      st.read();
      st.compute();
      // st.show();
      st.write();
    }
  }

  String inFile = null;
  String outFile = null;
  String[] fList = null; // 1-based
  double[][] similarMap = null; //  ̹ 絵 ǥ, 1-based
  int size = 0; // Էϴ ̹  
  int numColor = 64;
  Quantization quant = null;
  int[][] histogramList = null; // 1-based
  
  public Histogram(String in,String out) throws Exception {
    inFile = in;
    outFile = out;
  }
  
  public void read() throws Exception {
    System.out.println(" : "+inFile+"  д´.");
    FileReader fr = new FileReader(inFile);
    BufferedReader br = new BufferedReader(fr);
    
    String aLine = null;
    int idx=1;
    aLine = br.readLine();
    size = Integer.parseInt(aLine);
    fList = new String[size+1];
    similarMap = new double[size+1][size+1];
    for (int i=0; i<=size; i++) {
      similarMap[i] = new double[size+1];
    }
    for (int i=1; i<=size; i++) {
      similarMap[i][i] = 1.0;
    }
    while (null != (aLine=br.readLine())) {
      fList[idx++] = aLine;
    }

    histogramList = new int[size+1][numColor];
    quant = QuantizationFactory.makeSimpleQuantization(4, 4, 4);
    br.close();
    fr.close();
  }
  
  public void write() throws Exception {
    System.out.println("絵 ǥ "+outFile+" Ϸ .");
    FileWriter fw = new FileWriter(outFile);
    PrintWriter pw = new PrintWriter(fw);
    
    pw.println(size);
    for (int i=1; i<=size; i++) {
      for (int j=i+1; j<=size; j++) {
        pw.println(i+" "+j+" "+similarMap[i][j]);
      }
    }
    
    pw.close();
    fw.close();
  }
  
  public void show() {
    System.out.println("絵 ǥ  ȭ鿡 ش.");
    for (int i=1; i<=size; i++) {
      for (int j=1; j<=size; j++) {
        System.out.print(" "+similarMap[i][j]);
      }
      System.out.println();
    }
  }
  
  public void compute() {
    System.out.println("̹ 絵  Ѵ.");
    BufferedImage bi;
    for (int i = 1; i <= size; i++) {
      bi = Histogram.readImage(fList[i]);
      getHistogram(bi, histogramList[i]);
    }
    for (int i=1; i<size; i++) {
      for (int j=i+1; j<=size; j++) {
        similarMap[i][j] = 
          compareImageSimilarity(histogramList[i], histogramList[j]);
        similarMap[j][i] = similarMap[i][j];
      }
    }
  }
  
  /**
   *  ̹ ׷ ̷ 絵 Ѵ.
   * @param histoA ̹ ׷(迭)
   * @param histoB ̹ ׷(迭)
   */
  private double compareImageSimilarity(int[] histoA, int[] histoB) {
    int diff;
    double rate, total;
    total = 0.0;
    for (int i = 0; i < histoA.length; i++) {
      diff = Math.abs(histoA[i] - histoB[i]);
      rate = (double)diff / (1 + histoA[i] + histoB[i]);
      total += rate;
    }
    return total;
  }

  /**
   * RGB ÷ ̹ ׷ Ѵ.
   * @param bi RGB ̹
   * @param nColor ȭ 
   * @param histogram ÷ ׷(1 迭)
   */
  private void getHistogram(BufferedImage bi, int[] histogram) {
    int width = bi.getWidth();
    int height = bi.getHeight();
    int[][] red = readData(bi, 0);
    int[][] green = readData(bi, 1);
    int[][] blue = readData(bi, 2);
    for (int i = 0; i < histogram.length; i++) {
      histogram[i] = 0;
    }
    for (int r = 0; r < height; r++) {
      for (int c = 0; c < width; c++) {
        histogram[quant.table[quant.channel1st[red[r][c]]]
                             [quant.channel2nd[green[r][c]]]
                             [quant.channel3rd[blue[r][c]]]
                  ]++;
      }
    }
  }
  
  private static BufferedImage readImage(String fname) {
    Frame frame = new Frame();
    Image im = Toolkit.getDefaultToolkit().getImage(fname);
    try {
      MediaTracker mt = new MediaTracker(frame);
      mt.addImage(im, 0);
      mt.waitForID(0);
    } catch (Exception e) {}
    BufferedImage bi = new BufferedImage(im.getWidth(frame),
        im.getHeight(frame),
        BufferedImage.TYPE_INT_RGB);
    bi.createGraphics().drawImage(im, 0, 0, null);
    return bi; 
  } 
  
  /**
   * ̹ о Ư  ȼ  .
   * @param im ⺻ ̹ Ŭ
   * @param band    ϳ. , RGB (:0~2)
   * @return 2 ȼ 
   */
  public static int[][] readData(BufferedImage im, int band) {
    Raster ra = null;
    int data1D[] = null;
    int data2D[][] = null;
    int w, h;
    ra = im.getData();
    w = ra.getWidth();
    h = ra.getHeight();
    data1D = new int[w*h];
    ra.getSamples(0,0,w,h,band,data1D);
    data2D = new int[h][];
    for (int i=0; i<h; i++) {
      data2D[i] = new int[w];
    }
    for (int r=0; r<h; r++) {
      for (int c=0; c<w; c++) {
        data2D[r][c] = data1D[r*w+c];
      }
    }
    return data2D;
  }
  
} // end of SimilarTest
