package net.kldp.cats.core;


/**
 * KMeans Clustering 
 * @author 
 * @history 2006.8.16
 * @history 2006-09-03 sjkim
 *  ׷  ڵ ã ޼ҵ带 ̹Ŭ͸ Ŭ ű.
 * 
 */
public class KMeansClustering extends ImageClustering {
	final float Match = 0;
	int ClusterStandard[];
	
  /**
   * 
   * @throws Exception
   */
  public KMeansClustering() {
  }

	/**
	 * 
	 * @param Folder Ư 
	 * @throws Exception
	 */
	KMeansClustering(String Folder) throws Exception{
		System.out.println("====== clustering processing =======================================");
		read(Folder + "\\SimilarFile.dat");
		compute(10);
		write(Folder + "\\KMeansClusterFile.dat");
		System.out.println("====================================================================\n\n");
		
	}
	
	/**
	 * override 
	 */
	public void compute(int Num) throws Exception{
		
		if(Num>0) ClusterNum=Num;
		else ClusterNum =  FindClusterNum();  
			
		ClusterStandard = new int[ClusterNum];
		for(int i=0;i<ClusterNum;i++){
			ClusterStandard[i] = -1;
		}

		for(int i=0;i<2;i++)
			KMeans(ClusterNum,i);
	}
	
	/**
	 * ClusterStandard  絵   ClusterStandard  ã´.
	 * @param cmp Ư ̹ ȣ
	 * @return ClusterStandard  cmp  絵   ̹ ȣ.
	 */
	private int findHighSimilar(int cmp){
		int result = -2;
		float SimilarCmp=-1;
		float Similar = 100000;


		for(int i=0;i<ClusterNum;i++){
			if(SimilarData[cmp][ClusterStandard[i]]>=0)
				SimilarCmp = SimilarData[cmp][ClusterStandard[i]];
			else if(SimilarData[ClusterStandard[i]][cmp]>=0)
				SimilarCmp = SimilarData[ClusterStandard[i]][cmp];
			else{
				continue;
			}

			if(Similar > SimilarCmp){
				Similar = SimilarCmp;
				result = ClusterStandard[i];
			}
		}
		return result;
	}
	
	/**
	 *  KMeans ˰
	 * @param K Ŭ͸  
	 * @param times ° ݺ ȣ ǰ ִ Ȯϱ  
	 * @return true :  ݺ ȣ Ǿ   false : ̻ ȣ  ʾƾ 
	 * @throws Exception 
	 */
	private boolean KMeans(int K,int times) throws Exception{

		if(times==0){
			FindFirstClusterStandard(K);
		}

		for(int i = 0 ;i<Data_Count;i++){
			Cluster[i]=-1;
		}
		for(int i = 0 ;i<K;i++){
			Cluster[ClusterStandard[i]]=ClusterStandard[i];
		}
		
		int tmp=0;
		for(int i=0;i<Data_Count;i++){
			if(Cluster[i]!=-1) continue;
			tmp = findHighSimilar(i);
			if(tmp>=0){
				Cluster[i] = tmp;
				FindClusterStandard(K, tmp);
			}
			
		}
		if(times==0){
			for(int i=0;i<Data_Count;){

				
				int j=0;
				for(j=0;j<K;j++){
					if(Cluster[i] == ClusterStandard[j]){
						i++;
						break;
					}
				}
				if(j>=K){
					Cluster[i] = Cluster[Cluster[i]];
					
				}
				
			}
		
		}

		
		if(times==0) return false;
		
		return true;
	
	}

	/**
	 * Ư 絵(limit)ٴ ,   絵 ϱ
	 * @param limit ̹ ִ  Ư 絵
	 * @param StandardCount ̹  ClusterStandard 
	 * @return
	 */
	private int[] FindMax(float limit, int StandardCount){
		float tmpSimilarData[][] = new float[Data_Count][Data_Count];
		for(int i=0;i<Data_Count;i++){
			for(int j=0;j<Data_Count;j++){
				tmpSimilarData[i][j] = SimilarData[i][j];
			}
		}
		
		
		int[] ReturnData= new int[2];
		float tmpMax = 0 ;
		if(StandardCount==0){
			for(int i=0;i<Data_Count;i++){
				for(int j=0;j<Data_Count;j++){
					if(tmpSimilarData[i][j] >= limit && limit>0) continue;
					if(tmpSimilarData[i][j] > tmpMax){
						tmpMax = tmpSimilarData[i][j];
						ReturnData[0]=i;
						ReturnData[1]=j;
					}
					
				}
			}

			return ReturnData;
				
		}else{
			for(int i=0;i<StandardCount-1;i++){
				for(int j=i;j<StandardCount;j++){
					
					tmpSimilarData[ClusterStandard[i]][ClusterStandard[j]]=0;

				}
			}
			
			
			
			
			ReturnData[1]=-1;
			float Compare =0 , MaxCompare =0;
			int MaxLine=-1;
			for(int i=0;i<Data_Count;i++){
				Compare=0;
				for(int j=0;j<StandardCount-1;j++){
					if( i==ClusterStandard[j] ) continue;
					for(int k=j;k<StandardCount;k++){
						if( i==ClusterStandard[k] ) continue;
						Compare = Compare + tmpSimilarData[i][ClusterStandard[j]]+ tmpSimilarData[ClusterStandard[j]][i]-1;
						Compare = Compare + tmpSimilarData[i][ClusterStandard[k]]+ tmpSimilarData[ClusterStandard[k]][i]-1;
						
					}
					
					
				}
				if(MaxCompare < Compare){
					MaxCompare = Compare;
					MaxLine = i;
				}
			}
			ReturnData[0] = MaxLine;
			return ReturnData;
		}
		
	}
	
/**
 * ݺ ClusterStandard ϱ
 * @param K ClusterNum
 * @param ClusterValue Ư ŬͰ 
 * @return  ߴ 
 */
	
	private boolean FindClusterStandard(int K , int ClusterValue){
		
		int ClusterOrder = -1;
		for(int i=0;i<K;i++){
			if(ClusterStandard[i]==ClusterValue) {
				ClusterOrder = i;
				break;
			}
		}

		int[] tmpDataInCluster = new int[Data_Count];
		float tmpSimilar = 0;
		int tmpCount=0;
		int tmpOldStandard = -1;
		int NewStandard = -1;

		

		float MinData = 1000;
		tmpCount=0;
		tmpOldStandard=ClusterStandard[ClusterOrder];

		for(int j=0;j<Data_Count;j++){
			tmpDataInCluster[j] = -1;
		}

		for(int j=0;j<Data_Count;j++){
			if(Cluster[j] == tmpOldStandard){
				tmpDataInCluster[tmpCount] = j;
				tmpCount++;
			}
		}
			
		if(tmpCount==1){
			NewStandard = tmpOldStandard;
		}else{
			for(int j=0;j<tmpCount-1;j++){			
				for(int k=j+1;k<tmpCount;k++){				
					if(SimilarData[tmpDataInCluster[j]][tmpDataInCluster[k]]>=0){					
						tmpSimilar = SimilarData[tmpDataInCluster[j]][tmpDataInCluster[k]];						
					}else{						
						tmpSimilar = SimilarData[tmpDataInCluster[k]][tmpDataInCluster[j]];						
					}
						
					
					if(tmpSimilar<MinData ) {					
						MinData = tmpSimilar;						
						if(tmpDataInCluster[j] > 0 ){						
							NewStandard = tmpDataInCluster[j];

						}else {
							
							NewStandard = tmpDataInCluster[k];
						}
					}
				}
			}
		}
				
		ClusterStandard[ClusterOrder] = NewStandard;

		for(int i=0;i<Data_Count;i++){
			if(Cluster[i] == tmpOldStandard) Cluster[i] = NewStandard;
		}

				
	
		
		return true;
	}

	/**
	 * ó ClusterStandard ϴ Լ
	 * @param K ClusterNum
	 * @return  ߴ 
	 */
	private boolean  FindFirstClusterStandard(int K){
		ClusterNum = K;
		Cluster = new int[Data_Count];

		if(Data_Count == K){
			for(int i=0;i<Data_Count;i++){
				Cluster[i]=i;				
			}
			return true;
		}else{
			for(int i=0;i<Data_Count;i++){
				Cluster[i]=-1;
			}
		}

		for(int i = 0 ;i<Data_Count;i++){
			for(int j=0;j<Data_Count;j++){
				if(i==j) continue;
				if(SimilarData[i][j]<=Match && SimilarData[i][j]>=0){ // image perfect match
					Cluster[i]=j;
					break;
				}
			}
		}
		
		int StandardCount=0;
		float SimilarMaxData = 0;

		int[] tmp = new int[2];
		
		while(true){
			if(StandardCount==0){
				tmp = FindMax(0,StandardCount);
				ClusterStandard[0] = tmp[0];
				ClusterStandard[1] = tmp[1];
				StandardCount=2;
				continue;
			}else if(StandardCount>=ClusterNum){
				
				return true;
			}
			else{
				tmp = FindMax(SimilarMaxData,StandardCount);
			
			
				if(tmp[0]<0) {
					System.out.println(" threshold  ʹ ũų, K   ʹ ۽ϴ. ");
					return false;
				}
				ClusterStandard[StandardCount] = tmp[0];
				StandardCount++;
			}
		}
		
	}
  
	/**
	 * ׽Ʈ 
	 */
	public void TestPrint(){
		System.out.println("===== Clustering Test Print ====================================");
///Test Print//////////////////////////////////////////////////	
	    System.out.println();
	    for(int i=0;i<Data_Count;i++)
	    	System.out.print(Cluster[i]+1+" ");
	    System.out.println();
	    
	    System.out.println("========== ӽ ==========");
	    System.out.print("Cluster  : " + ClusterNum +"   (׸ ȣ 1   ۵)");
	    System.out.println();
	    System.out.print("Cluster   : ");
	    for(int i=0;i<ClusterNum;i++)
	    	System.out.print(ClusterStandard[i]+1+" ");
	    System.out.println("===============================================================\n\n");
//////////////////////////////////////////////////////////////	  
	}

	

}
