package net.kldp.cats.core;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.StringTokenizer;


/**
 * @deprecated 2006-08-21
 */
public class Kmeans {
	
	final float Threshold = (float) 28.5;
	final float Match = 0;
	int Data_Count;
	float SimilarData[][];
	int ClusterNum;
	int ClusterStandard[];
	int Cluster[];
	
	Kmeans() throws Exception{
		System.out.println("====== clustering processing =======================================");
		StartClustering("");
		System.out.println("====================================================================\n\n");
	}


	Kmeans(String Folder) throws Exception{
		System.out.println("====== clustering processing =======================================");
		StartClustering(Folder+"\\");
		System.out.println("====================================================================\n\n");
	}

    public Kmeans(String Folder, String cmp, String grp, int num) throws Exception {
        System.out.println("====== clustering processing =======================================");
        StartClustering(Folder, cmp, grp, num);
        System.out.println("====================================================================\n\n");      
    }
    
    private void StartClustering(String Folder, String cmp, String grp, int num) throws Exception{
        InputImg(Folder + "/" + cmp);
        ClusterNum =  FindClusterNum();  
    
        ClusterNum = num; // 10;
    
        ClusterStandard = new int[ClusterNum];
        for(int i=0;i<ClusterNum;i++){
            ClusterStandard[i] = -1;
        }

        for(int i=0;;i++){
            if(!K_Means(ClusterNum,i))break;

        }
            
        OutputSimilar(Folder + "/" + grp);
    }
    
	private void StartClustering(String Folder) throws Exception{
		InputImg(Folder+"SimilarFile.dat");
		ClusterNum =  FindClusterNum();  
	
		ClusterNum=10;
	
		ClusterStandard = new int[ClusterNum];
		for(int i=0;i<ClusterNum;i++){
			ClusterStandard[i] = -1;
		}

		for(int i=0;;i++){
			if(!K_Means(ClusterNum,i))break;

		}
			
		OutputSimilar(Folder+"ClusterFile.dat");
	
			
	}
	
	private int findHighSimilar(int cmp){
		int result = -1;
		float SimilarCmp=-1;
		float Similar = 1000;
		for(int i=0;i<ClusterNum;i++){
			SimilarCmp = SimilarData[cmp][ClusterStandard[i]]+SimilarData[ClusterStandard[i]][cmp]-1;


			if(Similar > SimilarCmp){
				Similar = SimilarCmp;
				result = ClusterStandard[i];
			}
		}
		return result;
	}
	
	private boolean K_Means(int K,int times){

		if(times == 0 )FindFirstClusterStandard(K);
		else{
			if(!FindClusterStandard(K)) return false;
		}
		
		for(int i = 0 ;i<K;i++){
			Cluster[ClusterStandard[i]]=ClusterStandard[i];
			
		}
		
		for(int i=0;i<Data_Count;i++){
	
			Cluster[i] = findHighSimilar(i);
			

		}
		for(int i=0;i<Data_Count;){
		
			int j=0;
			for(j=0;j<K;j++){
				if(Cluster[i] == ClusterStandard[j]){
					i++;
					break;
				}
			}
			if(j==K){
				System.out.println("      Cluster["+i+"] : " +Cluster[i]);
				Cluster[i] = Cluster[Cluster[i]];
				i++;
			}
			
		}
		
		
		
		/*
		 * 
	
		
		int check=0, check2 = 0;
		while(true){
			check=0;
			for(int i=0;i<Data_Count;i++){
				for(int j=0;j<ClusterNum;j++){
					if(Cluster[i]!= ClusterStandard[j]) check++;
					
				}
				if(check==ClusterNum){
					Cluster[i] = Cluster[Cluster[i]];
				}
			
			}
		}
*
		 * 
		 */
		return true;
	
	}

	private int[] FindMax(float limit, int StandardCount){
		float tmpSimilarData[][] = new float[Data_Count][Data_Count];
		for(int i=0;i<Data_Count;i++){
			for(int j=0;j<Data_Count;j++){
				tmpSimilarData[i][j] = SimilarData[i][j];
			}
		}
		
		
		int[] ReturnData= new int[2];
		float tmpMax = 0 ;
		if(StandardCount==0){
			for(int i=0;i<Data_Count;i++){
				for(int j=0;j<Data_Count;j++){
					if(tmpSimilarData[i][j] >= limit && limit>0) continue;
					if(tmpSimilarData[i][j] > tmpMax){
						tmpMax = tmpSimilarData[i][j];
						ReturnData[0]=i;
						ReturnData[1]=j;
					}
					
				}
			}

			return ReturnData;
				
		}else{
			for(int i=0;i<StandardCount-1;i++){
				for(int j=i;j<StandardCount;j++){
					
					tmpSimilarData[ClusterStandard[i]][ClusterStandard[j]]=0;

				}
			}
			
			
			
			
			ReturnData[1]=-1;
			float Compare =0 , MaxCompare =0;
			int MaxLine=-1;
			for(int i=0;i<Data_Count;i++){
				Compare=0;
				for(int j=0;j<StandardCount-1;j++){
					if( i==ClusterStandard[j] ) continue;
					for(int k=j;k<StandardCount;k++){
						if( i==ClusterStandard[k] ) continue;
						Compare = Compare + tmpSimilarData[i][ClusterStandard[j]]+ tmpSimilarData[ClusterStandard[j]][i]-1;
						Compare = Compare + tmpSimilarData[i][ClusterStandard[k]]+ tmpSimilarData[ClusterStandard[k]][i]-1;
						
					}
					
					
				}
				if(MaxCompare < Compare){
					MaxCompare = Compare;
					MaxLine = i;
				}
			}
			ReturnData[0] = MaxLine;
//			System.out.println("MaxCompare : "+MaxCompare);
//			System.out.println(" ReturnData : "+ReturnData[0]);
			return ReturnData;
		}
		
	}
	
	private boolean FindClusterStandard(int K){
		int[] tmpDataInCluster = new int[Data_Count];
		int check=0;
		float tmpSimilar = 0;
		int tmpCount=0;
		int tmpStandard = -1;
		int NewStandard = -1;
		
		float MinData ;
		for(int i=0;i<ClusterNum;i++){
			MinData = 1000;
			tmpCount=0;
			tmpStandard=ClusterStandard[i];
			for(int j=0;j<Data_Count;j++){
				tmpDataInCluster[j] = -1;
			}
			
			for(int j=0;j<Data_Count;j++){
				if(Cluster[j] == tmpStandard){
					tmpDataInCluster[tmpCount] = j;
					tmpCount++;
				}
			}
			if(tmpCount==1){
				NewStandard = tmpStandard;
			}else{
				for(int j=0;j<tmpCount-1;j++){
					for(int k=j;k<tmpCount;k++){
						if(SimilarData[tmpDataInCluster[j]][tmpDataInCluster[k]]>0){
							tmpSimilar = SimilarData[tmpDataInCluster[j]][tmpDataInCluster[k]];
						}else{
							tmpSimilar = SimilarData[tmpDataInCluster[k]][tmpDataInCluster[j]];
						}
						
						if(tmpSimilar<MinData) {
							MinData = tmpSimilar;
							NewStandard = tmpDataInCluster[j];// or k
						}
					}
				}
			}
				
			
			
			ClusterStandard[i] = NewStandard;
			if(NewStandard == tmpStandard) check++;
			
		}
	
		if(check == K) return false;
		return true;
	}


	private boolean  FindFirstClusterStandard(int K){
		ClusterNum = K;
		Cluster = new int[Data_Count];

		if(Data_Count == K){
			for(int i=0;i<Data_Count;i++){
				Cluster[i]=i;				
			}
			return true;
		}else{
			for(int i=0;i<Data_Count;i++){
				Cluster[i]=-1;
			}
		}

		for(int i = 0 ;i<Data_Count;i++){
			for(int j=0;j<Data_Count;j++){
				if(i==j) continue;
				if(SimilarData[i][j]<=Match && SimilarData[i][j]>=0){ // image perfect match
					Cluster[i]=j;
					for(int k=0;k<Data_Count;k++){
						SimilarData[i][k] = -1;
						SimilarData[k][i] = -1;
					}
					break;
				}
			}
		}
		
		int StandardCount=0;
		float SimilarMaxData = 0;

		int[] tmp = new int[2];
		
		while(true){
			if(StandardCount==0){
				tmp = FindMax(0,StandardCount);
				ClusterStandard[0] = tmp[0];
				ClusterStandard[1] = tmp[1];
				StandardCount=2;
				continue;
			} else if(StandardCount>=ClusterNum) return true;
			else tmp = FindMax(SimilarMaxData,StandardCount);
			
			if(tmp[0]<0) {
				System.out.println(" threshold  ʹ ũų, K   ʹ ۽ϴ. ");
				return false;
			}
			ClusterStandard[StandardCount] = tmp[0];
			StandardCount++;
		}
	}
	
	private int FindClusterNum(){

		int Num=0;
		for(int i=0;i<Data_Count;i++){
			for(int j=0;j<Data_Count;j++){
				if(Num >= Data_Count){
//					System.out.println("Ӱ谪(Threshold) ʹ ۽ϴ.  ũ  ּ.");
					return Data_Count;
				}

				if(SimilarData[i][j]>Threshold) Num++;
			}
		}
	
		
		if(Num <= 1){
//			System.out.println("Ӱ谪(Threshold) ʹ Ůϴ.  ۰  ּ.");
			return Data_Count;
		}
		else return Num;
	}

	private void InputImg (String File_Name) throws Exception {
		StringTokenizer st = null;
		System.out.println("Input : " + File_Name);
	
		FileReader File_Reader = new FileReader(File_Name);
		BufferedReader Buffer_Reader = new BufferedReader(File_Reader);
		
		String LineTmp = null;
		
		LineTmp = Buffer_Reader.readLine();
		Data_Count = Integer.parseInt(LineTmp);
		String[] StrTmp = new String[Data_Count];
		SimilarData = new float[Data_Count][Data_Count];
		int count = 0, tmp_i=0, tmp_j=0;
		for(int i=0;i<Data_Count;i++){
			for(int j=0;j<Data_Count;j++){
				SimilarData[i][j] = -1;
			}
		}
		while((LineTmp = Buffer_Reader.readLine())!=null){
			count = 0;
			
			st  = new StringTokenizer(LineTmp);
			while(st.hasMoreTokens()){
				StrTmp[count] = st.nextToken();
				count++;
			}

			
			tmp_i = Integer.parseInt(StrTmp[0])-1;
			tmp_j = Integer.parseInt(StrTmp[1])-1;
			SimilarData[tmp_i][tmp_j] = Float.parseFloat(StrTmp[2]);

		}
		File_Reader.close();
		Buffer_Reader.close();
		
	}

	private void OutputSimilar (String File_Name) throws Exception {
		
	    FileWriter File_Writer = new FileWriter(File_Name);
	    PrintWriter Print_Writer = new PrintWriter(File_Writer);
	    
	    Print_Writer.println(ClusterNum);
	    int check = 0;
	    
	    for(int i=0;i<Data_Count;i++){
	    	for(int j=0;j<Data_Count;j++){
	    		
	    		if((Cluster[j]) == i) {
	    			check = 1;
	    			Print_Writer.print(j+1+" ");
	    		}
	    	}
	    	if(check==1) {
	    		Print_Writer.println();
	    		check =0;
	    	}
	    }


	    
	    
	    Print_Writer.close();
	    File_Writer.close();
	    
	    System.out.println("Output : " + File_Name);
	
	    
	}

	public void TestPrint(){
		System.out.println("===== Clustering Test Print ====================================");
///Test Print//////////////////////////////////////////////////	
	    System.out.println();
	    for(int i=0;i<Data_Count;i++)
	    	System.out.print(Cluster[i]+1+" ");
	    System.out.println();
	    
	    System.out.println("========== ӽ ==========");
	    System.out.print("Cluster  : " + ClusterNum +"   (׸ ȣ 1   ۵)");
	    System.out.println();
	    System.out.print("Cluster   : ");
	    for(int i=0;i<ClusterNum;i++)
	    	System.out.print(ClusterStandard[i]+1+" ");
	    System.out.println("===============================================================\n\n");
//////////////////////////////////////////////////////////////	  
	}

}
