package net.kldp.cats.core;
import java.awt.Frame;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.awt.image.Raster;


/**
 * 
 * @author sjkim
 * @history 2006-08-11 
 */
public class Util {
  /**
   *  ̹ ׷ ̷ 絵 Ѵ.
   * @param histoA ̹ ׷(1 迭)
   * @param histoB ̹ ׷(1 迭)
   */
  public static double compare(int[] histoA, int[] histoB) {
    int diff;
    double rate, total;
    total = 0.0;
    for (int i = 0; i < histoA.length; i++) {
      diff = Math.abs(histoA[i] - histoB[i]);
      rate = (double)diff / (1 + histoA[i] + histoB[i]);
      total += rate;
    }
    return total;
  }

  /**
   *  ̹ ڸα׷ 絵 Ѵ.
   * @param corA ̹ ڸα׷(, 2 迭)
   * @param corB ̹ ڸα׷(, 2 迭)
   */
  public static double compare(double[][] corA, double[][] corB) {
    double diff;
    double rate, total;
    total = 0.0;
    for (int r = 0; r < corA.length; r++) {
      for (int c = 0; c < corA[0].length; c++) {
        diff = Math.abs(corA[r][c] - corB[r][c]);
        rate = (double)diff / (1 + corA[r][c] + corB[r][c]);
        total += rate;
      }
    }
    return total;
  }

  /**
   *  ̹ ׷ ̷ 絵 Ѵ.
   *  
   * @param histoA ̹ ׷(1 迭)
   * @param histoB ̹ ׷(1 迭)
   */
  public static double compareOld(int[] histoA, int[] histoB) {
    int diff, total;
    diff = total = 0;
    for (int i = 0; i < histoA.length; i++) {
      diff += Math.abs(histoA[i] - histoB[i]);
      total = histoA[i];
    }
    return (double)diff / (double)total;
  }

  /**
   *  ̹ ڸα׷ 絵 Ѵ.
   *  
   * @param corA ̹ ڸα׷(, 2 迭)
   * @param corB ̹ ڸα׷(, 2 迭)
   */
  public static double compareOld(double[][] corA, double[][] corB) {
    double diff, total;
    diff = total = 0.0;
    for (int r = 0; r < corA.length; r++) {
      for (int c = 0; c < corA[0].length; c++) {
        diff += Math.abs(corA[r][c] - corB[r][c]);
        total += corA[r][c];
      }
    }
    return diff / total;
  }

  /**
   * ̹  д´.
   * @param fname ̹  ̸()
   * @return BufferedImage(⺻ ̹ Ŭ)
   */
  public static BufferedImage readImage(String fname) {
    Frame frame = new Frame();
    Image im = Toolkit.getDefaultToolkit().getImage(fname);
    try {
      MediaTracker mt = new MediaTracker(frame);
      mt.addImage(im, 0);
      mt.waitForID(0);
    } catch (Exception e) {}
    BufferedImage bi = new BufferedImage(im.getWidth(frame),
        im.getHeight(frame),
        BufferedImage.TYPE_INT_RGB);
    bi.createGraphics().drawImage(im, 0, 0, null);
    return bi; 
  } 
  
  /**
   * ̹ о Ư  ȼ  .
   * @param im BufferedImage(⺻ ̹ Ŭ)
   * @param band    ϳ. , RGB (:0~2)
   * @return 2 ȼ 
   */
  public static int[][] readData(BufferedImage im, int band) {
    Raster ra = null;
    int data1D[] = null;
    int data2D[][] = null;
    int w, h;
    ra = im.getData();
    w = ra.getWidth();
    h = ra.getHeight();
    data1D = new int[w*h];
    ra.getSamples(0,0,w,h,band,data1D);
    data2D = new int[h][];
    for (int i=0; i<h; i++) {
      data2D[i] = new int[w];
    }
    for (int r=0; r<h; r++) {
      for (int c=0; c<w; c++) {
        data2D[r][c] = data1D[r*w+c];
      }
    }
    return data2D;
  }
}
