package net.kldp.cats.ui;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;

import javax.swing.JTextArea;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;

/**
 * α׷(Ŭ) ȭ Ʒʿ  ϴ ó
 * ǥ ° ǥ  ȭ鿡 ش.
 * 
 *   : 
 * 1.  ޼ҵ忡 ǥ ȭ鿡 ش.
 * <code>JTextArea textArea;
 * ...
 * System.setOut(new PrintStream(
 *     new ConsoleOutputStream(textArea.getDocument(), System.out),
 *                             true));
 * ǥؿ ȭ鿡 ش.
 * System.setErr(new PrintStream(
 *     new ConsoleOutputStream(textArea.getDocument(), System.err),
 *                             true));</code>
 * 2. ڵ ũ ϵ JTextArea  Ѵ.
 * <code>JTextArea textArea;
 * ...
 * System.setOut(new PrintStream(
 *     new ConsoleOutputStream(textArea, System.out), true));
 * ǥؿ ȭ鿡 ش.
 * System.setErr(new PrintStream(
 *     new ConsoleOutputStream(textArea, System.err), true));</code>
 *
 * ǻ :
 * ConsoleOutputStream ׻ ڵ Ϸ(flush)ϵ Ķ͸ true Ѵ.
 * ϷḦ    ȭ鿡 Ÿ ʴ´.
 *  1 ص ؽƮ Ʈ ũ⸦   ڵ ũ Ȥ ȵǴ
 * 찡 ִ. ܸ ó ʾƼ Ʈ̽  ,
 * ð  ɸ ۾   .
 * 
 * @see <a href='http://forum.java.sun.com/thread.jspa?forumID=57&threadID=708957'>
 * Swing : How to implement a JTextArea that emulates the console (messages)?</a>
 * @see <a href='http://forum.java.sun.com/thread.jspa?forumID=57&threadID=608660'>
 * Swing : Printing System.out data to JEditorPane, reply 1 of 2</a>
 * @see <a href='http://forum.java.sun.com/thread.jspa?forumID=57&threadID=410423'>
 * Swing : JTextComponent/JScrollPane problem, reply 9 of 11</a>
 *     
 * @author camickr@forum.java.sun.com
 * @author sjkim
 * 
 * @history 2005-03-20 
 * @history 2006-08-11 ڵ Ÿ 
 * @history 2006-08-26 JTextArea  ؼ ڵ ũ Ѵ.
 */
public class ConsoleOutputStream extends OutputStream {
  protected JTextArea textArea;
  protected Document document = null;
  protected ByteArrayOutputStream outputStream =
          new ByteArrayOutputStream(256);
  protected PrintStream ps = null;

  public ConsoleOutputStream(Document document, PrintStream ps) {
    textArea = null;
    this.document = document;
    this.ps = ps;
  }
  
  public ConsoleOutputStream(JTextArea textArea, PrintStream ps) {
    this.textArea = textArea;
    this.document = textArea.getDocument();
    this.ps = ps;
  }
 
  public void write(int b) {
    outputStream.write (b);
  }

  public void flush() throws IOException {
    super.flush();
    if (document != null) {
      try {
        document.insertString(document.getLength (),
                   new String(outputStream.toByteArray()),
                   null);
      } catch (BadLocationException e) {}          
    }
      
    if (ps != null) {
      ps.write(outputStream.toByteArray());
    }
    
    outputStream.reset(); 
    
    if (null != textArea) {
      textArea.setCaretPosition(document.getLength());
    }
  }
}


