package net.kldp.cats.ui;

import java.awt.event.KeyEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.image.BufferedImage;
import java.awt.Event;
import java.awt.BorderLayout;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.KeyStroke;
import javax.swing.JPanel;
import javax.swing.JMenuItem;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.JLabel;
import javax.swing.JTextField;

import net.kldp.cats.core.Util;

public class DisplayFrame extends JFrame {

  /**
   * 
   */
  private static final long serialVersionUID = 1L;
  private JPanel jContentPane = null;
  private DisplayPanel displayPanel = null;
  private JScrollPane jScrollPane = null;
  private JPanel jPanel1 = null;
  private JSlider jSlider = null;
  private JLabel jLabel = null;
  private JFileChooser selector = null;
  /**
   * This method initializes displayPanel 
   *  
   * @return DisplayPanel 
   */
  private DisplayPanel getDisplayPanel() {
    if (displayPanel == null) {
      displayPanel = new DisplayPanel();
      displayPanel.setSize(new java.awt.Dimension(100,100));
    }
    return displayPanel;
  }
  
  /**
   * This method initializes jScrollPane  
   *  
   * @return javax.swing.JScrollPane  
   */
  private JScrollPane getJScrollPane() {
    if (jScrollPane == null) {
      jScrollPane = new JScrollPane();
      jScrollPane.setViewportView(getDisplayPanel());
    }
    return jScrollPane;
  }

  /**
   * This method initializes jPanel1  
   *  
   * @return javax.swing.JPanel 
   */
  private JPanel getJPanel1() {
    if (jPanel1 == null) {
      jLabel = new JLabel();
      jLabel.setText("100 %");
      jLabel.setPreferredSize(new java.awt.Dimension(0,20));
      jLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
      jPanel1 = new JPanel();
      jPanel1.setLayout(new BorderLayout());
      jPanel1.add(jLabel, java.awt.BorderLayout.NORTH);
      jPanel1.add(getJSlider(), java.awt.BorderLayout.CENTER);
    }
    return jPanel1;
  }

  /**
   * This method initializes jSlider  
   *  
   * @return javax.swing.JSlider  
   */
  private JSlider getJSlider() {
    if (jSlider == null) {
      jSlider = new JSlider();
      jSlider.setMaximum(300);
      jSlider.setMinimum(10);
      jSlider.setValue(100);
      jSlider.addChangeListener(new javax.swing.event.ChangeListener() {
        public void stateChanged(javax.swing.event.ChangeEvent e) {
          JSlider source = (JSlider) e.getSource();
          if (!source.getValueIsAdjusting()) {
            int percent = source.getValue();
            jLabel.setText(percent+" %");
            displayPanel.scale(percent);
          }
        }
      });
    }
    return jSlider;
  }

  /**
   * This is the default constructor
   */
  public DisplayFrame() {
    super();
    initialize();
  }

  /**
   * This method initializes this
   * 
   * @return void
   */
  private void initialize() {
    this.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
    this.setSize(509, 456);
    this.setContentPane(getJContentPane());
  }

  /**
   * This method initializes jContentPane
   * 
   * @return javax.swing.JPanel
   */
  private JPanel getJContentPane() {
    if (jContentPane == null) {
      jContentPane = new JPanel();
      jContentPane.setLayout(new BorderLayout());
      jContentPane.add(getJScrollPane(), java.awt.BorderLayout.CENTER);
      jContentPane.add(getJPanel1(), java.awt.BorderLayout.SOUTH);
    }
    return jContentPane;
  }
  
  public void setImage(File file) {
    String name = file.getName();
    if (name.lastIndexOf(".jpg") > -1 ||
        name.lastIndexOf(".gif") > -1) {
      setTitle("  : " + name);
      getDisplayPanel().set(Util.readImage(file.getAbsolutePath()));
      setVisible(true);
    } else {
      setVisible(false);
    }
  }

}  //  @jve:decl-index=0:visual-constraint="10,10"
