package net.kldp.cats.ui.FileExplorer;

import java.io.File;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Vector;

import javax.swing.AbstractListModel;
import javax.swing.filechooser.FileSystemView;

import net.kldp.cats.ui.ThumbsDB;

/**
 *  丮 ȿ ִ  丮  ȭ鿡 ִ
 * FileList Ŭ ϴ Ŭ
 * @see FileList
 * @author sjkim
 * @history 2006-08-11 
 * @history 2006-08-27 ̸ ͺ̽ ߰.
 * @history 2006-08-30 ̸ ͺ̽  ȭ鿡  ʵ 
 * subDirectory ޼ҵ忡 丮   κ 
 * getFileList ޼ҵ ̾Ƴ. 
 * @history 2006-09-01 FileExplorer Ű ű.
 */
public class FileListModel extends AbstractListModel {
  protected Vector vector = new Vector();
  protected FileSystemView filesystem;
  protected File directory;
  /** ̸ ͺ̽ */
  protected ThumbsDB thumbsDB = null;

  public FileListModel() {
    this(null);
  }
  
  /**
   * 
   * @param dir 丮 ()
   */
  public FileListModel(File dir) {
    init();
    if (null == dir) {
      directory = filesystem.getHomeDirectory();
    } else {
      directory = dir;
    }
    File[] list = filesystem.getFiles(directory, false);
    for (int i = 0; i < list.length; i++) {
      vector.add(list[i]);
    }
  }
  
  public void init() {
    filesystem = FileSystemView.getFileSystemView();
  }
  
  public Object getElementAt(int index) {
    return vector.get(index);
  }

  public int getSize() {
    return vector.size();
  }
  
  protected void reset(Object[] objs) {
    vector.removeAllElements();
    if (null != objs) {
      for (int i = 0; i < objs.length; i++) {
        vector.add(objs[i]);
      }
    }
  }
  
  /**
   *  丮  ´.
   * ⼭ ̸  ̽  ʴ´. 
   * @see FileListModel.reset(Object[] objs)
   * @param dir 丮 
   */
  protected void getFileList(File dir) {
    File[] list = filesystem.getFiles(dir, false);
    String name;
    Arrays.sort(list, new FileComparator());
    vector.removeAllElements();
    for (int i = 0; i < list.length; i++) {
      name = list[i].getName();
      if (0 > name.lastIndexOf(ThumbsDB.FILENAME)) {
        vector.add(list[i]);
      }
    }
  }
  
  /**
   * ȭ鿡  丮 θ Ѵ.
   * ̸ ͺ̽ аų  .
   * @param dir ȭ鿡  丮 
   */
  public void setDirectory(File dir) {
    if (null != dir) {
      directory = dir;
      getFileList(dir);
      if (filesystem.isFileSystem(dir) && dir.isDirectory()) {
        thumbsDB = ThumbsDB.createDB(dir);
      } else {
        thumbsDB = null;
      }
    } else {
      directory = null;
      reset(null);
    }
    fireContentsChanged(this, 0, vector.size() - 1);
  }
  
  /**
   *  ϱ   Ŭ
   * 켱 : 丮,  ̸
   * .
   * File[] list = filesystem.getFiles(dir, false);
   * Arrays.sort(list, new FileComparator());
   * .
   * 丮  ̰   Ϲ  δ.
   * @author sjkim
   */
  protected class FileComparator implements Comparator {
    public int compare(Object o1, Object o2) {
      File f1 = (File)o1;
      File f2 = (File)o2;
      if (f1.isDirectory()) {
        if (f2.isDirectory()) {
          return f1.compareTo(f2);
        } else if (f2.isFile()) {
          return -1;
        }
      } else if (f1.isFile()) {
        if (f2.isDirectory()) {
          return 1;
        } else if (f2.isFile()) {
          return f1.compareTo(f2);
        }        
      }
      return 0;
    }
  }
}