package net.kldp.cats.ui.FileExplorer;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Toolkit;
import java.io.File;
import java.net.MalformedURLException;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import javax.swing.border.Border;
import javax.swing.filechooser.FileSystemView;

import net.kldp.cats.ui.ThumbsDB;

/**
 *    ý  ȭ鿡 ְ   ۰ ش.
 * FileList Ŭ Ѵ.
 * .
 * FileList list;
 * ...
 * list.setCellRenderer(new FileRenderer(list));
 * @see FileList
 * @author sjkim
 * @history 2006-08-11 
 * @history 2006-08-16 ̸
 * @history 2006-08-27 ̸ ͺ̽ 
 * FileList ü ؼ ̸ ͺ̽ Ѵ.
 * @history 2006-09-01 FileExplorer Ű ű.
 */
public class FileRenderer extends JLabel implements ListCellRenderer {
  /** ̸ ͺ̽ ϱ  */
  protected FileList fileList;
  /**  Žó ϱ  ʿ ü */
  protected FileSystemView filesystem;
  /** 콺  丮 Ǵ    ׸   ׵θ */
  public final static Border border =
    BorderFactory.createLineBorder(Color.BLACK);

  public FileRenderer(FileList fileList) {
    super();
    init();
    this.fileList = fileList;
  }
  
  /**
   * ʱȭ
   * 丮, , Ϲ  ̹ д´.
   * dir.gif, pic.gif, file.gif ׸ ʿϴ.
   */
  private void init() {
    filesystem = FileSystemView.getFileSystemView();
    setOpaque(false);
    setHorizontalAlignment(JLabel.CENTER);
    setVerticalAlignment(JLabel.CENTER);
    setBackground(Color.WHITE);
    setPreferredSize(new Dimension(100, 115));
    setVerticalTextPosition(JLabel.BOTTOM);
    setHorizontalTextPosition(JLabel.CENTER);
  }

  /**
   * @override
   */
  public Component getListCellRendererComponent(JList list,
    Object value, int index,
    boolean isSelected, boolean cellHasFocus) {
    if (isSelected) {
      setBorder(border);
    } else {
      setBorder(null);
    }
    loadThumb((File)value);
    return this;
  }
  
  /**
   *   д´.
   * @param path   
   * @param text   
   * @return ̹ 
   */
  protected ImageIcon loadImageIcon(String path, String text) {
    Image image = Toolkit.getDefaultToolkit().createImage(path);
    return new ImageIcon(image, text);
  }

  /**
   *    ȭ鿡   ̹ Ѵ.
   * ̸ ͺ̽ ϵ Ͽ.
   * @see ImageFileFilter
   * @param file (丮, , Ÿ)
   * @history 2006-09-01 ̹ 
   */
  protected void loadThumb(File file) {
    String name;
    Image im = null;
    name = filesystem.getSystemDisplayName(file);
    setText(name);
    setToolTipText(name);
    name = file.getName();

    if (ThumbsDB.Filter.accept(file)) {
      setIcon(fileList.getThumbsDB().getIcon(name));
    } else {
      im = ((ImageIcon) filesystem.getSystemIcon(file)).getImage();
      setIcon(new ImageIcon(im.getScaledInstance(40, 40, Image.SCALE_SMOOTH)));
    }
  }  
}