package net.kldp.cats.ui.FileExplorer;
import javax.swing.*;
import javax.swing.event.TreeModelEvent;
import javax.swing.event.TreeModelListener;
import javax.swing.filechooser.FileSystemView;
import javax.swing.tree.*;
import java.io.*;

/**
 *   Ʈ  ý ϱ  Ʈ
 * ȭ ֻ ̴.
 * http://java.sun.com/products/jfc/tsc/articles/jtree/
 * @author Eric Armstrong, Tom Santos, Steve Wilson 
 * @author sjkim
 * @history 2006-08-07
 * @history 2006-08-08   Ž 丮 Ʈó .
 * @history 2006-09-01 FileExplorer Ű ű.
 */
public class FileSystemModel extends AbstractTreeModel implements Serializable {
  String currentNode;
  FileSystemView filesystem;

  public FileSystemModel() {
    this(System.getProperty("user.home"));
  }

  public FileSystemModel(String startPath) {
    currentNode = startPath;
    filesystem = FileSystemView.getFileSystemView();
  }
  
  /**
   *  ý ϱ  ü ȯѴ.
   * @return  ý ϱ  ü
   */
  public FileSystemView getFileSystemView() {
    return filesystem;
  }
  
  /**
   * ڽ  Ʈ( 丮) ȯѴ.
   * @param parent θ (丮)
   * @return ڽ  Ʈ(⼭  丮)
   */
  protected File[] getChildren(Object parent) {
    File[] children;
    File[] files = filesystem.getFiles((File)parent, false);
    int count = 0;
    for (int i = 0; i < files.length; i++) {
      if (filesystem.isDrive(files[i])) {
        continue;
      }
      if (files[i].isFile()) {
        count++;
      }
    }
    children = new File[files.length - count];
    for (int i = 0, j = 0; i < files.length; i++) {
      if (filesystem.isDrive(files[i])) {
        children[j++] = files[i];
        continue;
      }
      if (!files[i].isFile()) {
        children[j++] = files[i];
      }
    }
    return children;
  }
    
  public Object getRoot() {
    return filesystem.getHomeDirectory(); // ȭ
  }

  public Object getChild(Object parent, int index) {
    File[] children = getChildren(parent); 
    return children[index];
  }

  public int getChildCount(Object parent) {
    File fileSysEntity = (File)parent;
    if (!filesystem.isFileSystem(fileSysEntity) ||
        fileSysEntity.isDirectory() ) {
      File[] children = getChildren(parent);
      return children.length;
    } else {
      return 0;
    }
  }
  
  /**
   * 丮 ֱ  ܸ(Ϲ ) .
   * @param node 
   * @return false ׻ ܸ(Ϲ ) ƴϴ. 
   */
  public boolean isLeaf(Object node) {
    return false;
  }

  public void valueForPathChanged(TreePath path, Object newValue) {
  }

  public int getIndexOfChild(Object parent, Object child) {
    File directory = (File)parent;
    File fileSysEntity = (File)child;
    File[] children = getChildren(parent); 
    int result = -1;

    for (int i = 0; i < children.length; ++i) {
      if (fileSysEntity.equals(children[i])) {
        result = i;
        break;
      }
    }
    return result;
  }
  
  public String getSystemName(File file) {
    return filesystem.getSystemDisplayName(file);
  }
}