package net.kldp.cats.ui.FileExplorer;

import javax.swing.tree.*;
import javax.swing.event.*;
import java.util.*;

/**
 * TreeModelSupport
 * http://java.sun.com/products/jfc/tsc/articles/jtree/
 * @author Eric Armstrong, Tom Santos, Steve Wilson 
 * @history 2006-08-07
 * @history 2006-09-01 FileExplorer Ű ű.
 */
public class TreeModelSupport {
  private Vector vector = new Vector();
  
  /**
   * 
   * @param listener
   */
  public void addTreeModelListener(TreeModelListener listener) {
    if (listener != null && !vector.contains(listener)) {
      vector.addElement(listener);
    }
  }
  
  /**
   * 
   * @param listener
   */
  public void removeTreeModelListener(TreeModelListener listener) {
    if (listener != null) {
      vector.removeElement(listener);
    }
  }

  /**
   * 
   * @param e
   */
  public void fireTreeNodesChanged(TreeModelEvent e) {
    Enumeration listeners = vector.elements();
    while (listeners.hasMoreElements()) {
      TreeModelListener listener =
        (TreeModelListener)listeners.nextElement();
      listener.treeNodesChanged(e);
    }
  }

  /**
   * 
   * @param e
   */
  public void fireTreeNodesInserted(TreeModelEvent e) {
    Enumeration listeners = vector.elements();
    while (listeners.hasMoreElements()) {
      TreeModelListener listener =
        (TreeModelListener)listeners.nextElement();
      listener.treeNodesInserted(e);
    }
  }

  /**
   * 
   * @param e
   */
  public void fireTreeNodesRemoved(TreeModelEvent e) {
    Enumeration listeners = vector.elements();
    while (listeners.hasMoreElements()) {
      TreeModelListener listener =
        (TreeModelListener)listeners.nextElement();
      listener.treeNodesRemoved(e);
    }
  }

  /**
   * 
   * @param e
   */
  public void fireTreeStructureChanged(TreeModelEvent e) {
    Enumeration listeners = vector.elements();
    while (listeners.hasMoreElements()) {
      TreeModelListener listener =
        (TreeModelListener)listeners.nextElement();
      listener.treeStructureChanged(e);
    }
  }
}
