package net.kldp.cats.ui;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;

import net.kldp.cats.MovePictures;

/**
 *  ̵ϴ Ŭ
 * ϰų  ̵Ѵ.
 * @author sjkim
 * @history 2006-09-03 
 */
public class ImageMoving implements LongTask {
  public static final int ByMOVE = 1;
  public static final int ByCOPY = 2;
  
  protected int current;
  protected int lengthOfTask;
  protected MainFrame main;
  
  public ImageMoving(MainFrame frame) {
    current = 0;
    lengthOfTask = 1;
    main = frame;
  }

  /**
   *  Ѵ.
   * @param src    ̸
   * @param dst   ̸
   * @throws IOException  н
   */
  public static void copyFile(String src, String dst) throws IOException {
    File inputFile = new File(src);
    File outputFile = new File(dst);
    
    FileInputStream in = new FileInputStream(inputFile);
    FileOutputStream out = new FileOutputStream(outputFile);
    int c;
    
    while ((c = in.read()) != -1) {
      out.write(c);
    }
    
    in.close();
    out.close();
  }
  
  /**
   *  ġ ű.
   * @param src
   * @param dst
   */
  public static void moveFile(String src, String dst) {
    File inputFile = new File(src);
    File outputFile = new File(dst);
    String name, ext;
    int dotIdx;
    while (outputFile.exists()) {
      name = outputFile.getName();
      dotIdx = name.lastIndexOf('.');
      if (-1 < dotIdx) {
        ext = name.substring(dotIdx + 1, name.length());
        name = name.substring(0, dotIdx);
      } else {
        ext = "";
      }
      outputFile = new File(outputFile.getParent() + name + "-1." + ext);
    }
    try {
      if (!inputFile.renameTo(outputFile)) {
        System.out.println(outputFile + "  ű  ߽ϴ.");
      }
    } catch (SecurityException se) {
      System.out.println(outputFile + "    ϴ.");
    }
  }
  
  private String[] fileList = null;
  private int[][] groupList = null;
  
  /**
   * ()ϸƮ д´.
   * @param fname ()ϸƮ()
   * @throws IOException   Ͽ.
   */    
  public void readFileList(String fname) throws IOException {
    FileReader fr = new FileReader(fname);
    BufferedReader br = new BufferedReader(fr);
    String aLine = null;
    int idx=1, size;
    aLine = br.readLine();
    size = Integer.parseInt(aLine);
    fileList = new String[size+1];
    while (null != (aLine=br.readLine())) {
      fileList[idx++] = aLine;
    }    
    br.close();
    fr.close();
  }
  
  /**
   * з  (׷츮Ʈ) д´.
   * @param fname ׷츮Ʈ()
   * @throws IOException   Ͽ.
   */
  public void readGroupList(String fname) throws IOException {
    FileReader fr = new FileReader(fname);
    BufferedReader br = new BufferedReader(fr);
    String aLine = null;
    int idx=1, size, group;
    StringTokenizer st = null;
    aLine = br.readLine();
    size = Integer.parseInt(aLine);
    groupList = new int[size][];
    group = 0;
    while (null != (aLine=br.readLine())) {
      st = new StringTokenizer(aLine);
      if (st.hasMoreTokens()) {
        groupList[group] = new int[st.countTokens()];
      }
      int i = 0;
      while (st.hasMoreTokens()) {
        groupList[group][i++] = Integer.parseInt(st.nextToken());
      }
      group++;
    }    
    br.close();
    fr.close();    
  }
  
  /**
   * ()ϸƮ ׷츮Ʈ  д  Ѵ.
   */
  public void print() {
    if (null != fileList) {
      for (int i = 0; i < fileList.length; i++) {
        System.out.println(i + ":" + fileList[i]);
      }
    }
    if (null != groupList) {
      for (int i = 0; i < groupList.length; i++) {
        for (int j = 0; j < groupList[i].length; j++) {
          System.out.print(groupList[i][j]+" ");
        }
        System.out.println();
      }
    }
  }

  /**
   *   ϰų ̵Ѵ.
   * @param dir ۾丮
   * @param param û : ̵, 
   */
  public void move(String dir, int param) {
    File workingDir, subDir, file;
    String groupName = main.getGroupName();
    current = 0;
    lengthOfTask = fileList.length - 1;
    workingDir = new File(dir);
    if (!workingDir.isDirectory()) {
      System.out.println(dir + " 丮 ƴմϴ.");
      workingDir = new File(System.getProperty("user.dir"));
    }
    
    if (null != groupList) {
      for (int i = 0; i < groupList.length; i++) {
        subDir = new File(workingDir, groupName + i);
        subDir.mkdir();
        for (int j = 0; j < groupList[i].length; j++) {
          try {
            file = new File(fileList[groupList[i][j]]);
            current++;
            if (ImageMoving.ByCOPY == param) {
              ImageMoving.copyFile(fileList[groupList[i][j]],
                  subDir.getAbsolutePath() + File.separator +
                  file.getName());
            } else if (ImageMoving.ByMOVE == param) {
              ImageMoving.moveFile(fileList[groupList[i][j]],
                  subDir.getAbsolutePath() + File.separator +
                  file.getName());
            }
          } catch (IOException e) {
            e.printStackTrace();
          }
        }
      }
    }
  }

  public int getCurrent() {
    return current;
  }

  public int getLengthOfTask() {
    return lengthOfTask;
  }

  public String getMessage() {
    return (current * 100 / lengthOfTask) + " %   Դϴ.";
  }

  public boolean isDone() {
    return current >= lengthOfTask;
  }

}
