package net.kldp.cats.ui;

import java.awt.BorderLayout;

import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JTextArea;

import java.io.File;
import java.io.IOException;

import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JLabel;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.filechooser.FileSystemView;
import javax.swing.text.Document;
import java.awt.Dimension;
import javax.swing.JSplitPane;

import net.kldp.cats.ui.FileExplorer.FileList;
import net.kldp.cats.ui.FileExplorer.FileListModel;
import net.kldp.cats.ui.FileExplorer.FileSystemModel;
import net.kldp.cats.ui.FileExplorer.FileSystemTreePanel;
import net.kldp.cats.ui.ResultViewer.ResultPanel;

import javax.swing.JTabbedPane;

/**
 *  ڵ з ý ׷  ̽
 * 
 * ޴ :  з, ̸ ,  ,  , 
 *   Žó 丮  Ʈ ְ 丮  ū 
 * ش. 丮      ۰ ̸ ش.
 * 
 *  : 
 * MainFrame mainFrame = new MainFrame();
 * mainFrame.setVisible(true);
 * 
 * @author sjkim
 * 
 * @history 2006-07-18 
 * @history 2006-08-17
 * @history 2006-08-26 ȭ  ϴ JTextArea ٸ ü   ֵ
 * getTaOutput ޼ҵ带 public ƴ. 
 * @history 2006-09-01 showResult ޼ҵ ߰
 *  з   ȭ鿡 ش.
 * ǳ Ͽ  Ž  з     ֵ Ͽ.
 * @history 2006-09-03 Ķǳڿ ǳ 
 * ĶͰ 5 Ǵ 7 ̴.
 * getArguments ޼ҵ忡  ִ.
 *   з     丮 ù° ƱԸƮ ȯؾ ϴµ
 *  Ž⿡  Ž 丮 ȯѴ.
 *  з   ؾ ϰڴ.
 * @history 2006-09-08 getArguments ޼ҵ 
 * Ʈ ƴ ؽƮʵ忡 丮 θ ´.
 */
public class MainFrame extends JFrame
                       implements TreeSelectionListener {

  private static final long serialVersionUID = 1L;
  
  private FileSystemView filesystem = FileSystemView.getFileSystemView();
  private JFileChooser selector = null;
  private DisplayFrame displayFrame = new DisplayFrame();
  private HTMLViewer htmlViewer = new HTMLViewer(); 

  private JPanel jContentPane = null;

  private JTextArea taOutput = null;

  private JPanel topPanel = null;

  private JScrollPane jScrollPane = null;

  private JScrollPane jScrollPane1 = null;

  private JPanel pathPanel = null;

  private JTextField jTextField = null;

  private JLabel jLabel = null;
  
  private JScrollPane spOutput = null;
  
  private JSplitPane jSplitPane = null;
  
  private FileSystemTreePanel fileSystemTreePanel = null;
  
  private FileList fileList = null;

  private ParameterPanel parameterPanel = null;
  
  private MenuPanel menuPanel = null;

  private JTabbedPane jTabbedPane = null;

  /**
   * This is the default constructor
   */
  public MainFrame() {
    super();
    initialize();
  }

  /**
   * This method initializes this
   * 
   * @return void
   */
  private void initialize() {
    this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    this.setSize(820, 600);
    this.setContentPane(getJContentPane());
    this.setTitle(" ڵ з ý");
    
    selector = new JFileChooser(System.getProperty("user.dir"));
    selector.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
  }

  /**
   * TreeListener
   * @param e
   * @history 2006-08-25 SwingWorker 
   */
  public void valueChanged(TreeSelectionEvent e) {
    final FileListModel model = (FileListModel)getFileList().getModel();
    final JTextField path = getJTextField();
    final File fileSysEntity = (File)e.getPath().getLastPathComponent();
    getFileSystemTreePanel().getTree().doLayout();
    SwingWorker sw = new SwingWorker() {
      public Object construct() {
        System.out.println(" ġ : " + fileSysEntity);
        if (!filesystem.isFileSystem(fileSysEntity) || 
          fileSysEntity.isDirectory()) {
          model.setDirectory(fileSysEntity);
          if (filesystem.isFileSystem(fileSysEntity)) {
            path.setText(fileSysEntity.getPath());
          } else {
            path.setText(filesystem.getSystemDisplayName(fileSysEntity));
          }
        } else {
          model.setDirectory(null);
          path.setText("  ʾҽϴ.");
        }
        return null;
      }
    };
    sw.start();
  }

  /**
   * 
   * @author Eric Armstrong, Tom Santos, Steve Wilson
   * @author sjkim 
   * @deprecated 2006-08-17 MainFrame  ̽ 
   * @history 2006-08-07
   */
  protected static class TreeListener implements TreeSelectionListener {
    FileListModel model;
    FileSystemView filesystem;
    
    public TreeListener(FileListModel  mdl) {
      model = mdl;
      filesystem = FileSystemView.getFileSystemView();
    }
    
    public void valueChanged(TreeSelectionEvent e) {
      File fileSysEntity = (File)e.getPath().getLastPathComponent();
      System.out.println(fileSysEntity);
      if (!filesystem.isFileSystem(fileSysEntity) || 
        fileSysEntity.isDirectory()) {
        model.setDirectory(fileSysEntity);
      } else {
        model.setDirectory(null);
      }
    }
  }
  
  /**
   *  ڵ з ý ܼ ȯ濡   ʿ ɼ .
   * ɼ :( 6)
   * [  丮]
   * [ű 丮]
   * [絵   = histo, cor]
   * [ ȭ    = 8, 64, 512; 0  ȭ  ʴ´.]
   * [絵   cor   : ĶͰ 2  ִ.]
   *   (ȼ Ÿ = 3, 5, 7, 9), ( = 1, 2, 3)
   * [з  = kmeans, mst]
   * [׷ ]
   * . c:/testdata c:/group histo 64 kmeans 4
   * 
   * @return arguments
   * @history 2006-09-08 з  丮  κ 
   * Ʈ(丮 )  ʰ ġ ؽƮʵ忡 ٷ ´.
   */
  public String[] getArguments() {
    String[] args;
    String[] param;
    String source;
    source = getJTextField().getText();
    param = getParameterPanel().getParameters();
    args = new String[param.length + 1];
    args[0] = source;
    for (int i = 0; i < param.length; i++) {
      args[i + 1] = param[i];
    }
    return args;
  }
  
  public String getGroupName() {
    return getParameterPanel().getGroupName();
  }
  
  public int getMovingParam() {
    return getParameterPanel().getMovingParam();
  }
  
  /**
   *  â    ȭ鿡 ش.
   * ̹   ִ â   â ״ .
   *   ƴ 丮 Ϲ  ȭ鿡  ʴ´.
   * @param file
   */
  public void showImage(File file) {
    if (null == file) {
      file = (File) getFileList().getSelectedValue();
    }
    displayFrame.setImage(file); 
  }
  
  /**
   * HTML ۼ  ȭ鿡 ش.
   */
  public void showHelp() {
    // htmlViewer.show("./help/main.html");
    try {
      Runtime.getRuntime().exec("explorer help\\main.html");
    } catch (IOException e) {
      e.printStackTrace();
    }
  }
  
  /**
   *  з   ȭ鿡 ش.
   */
  public void showResult() {
    JTabbedPane pane = getJTabbedPane();
    ResultPanel rp = new ResultPanel(this);
    int count = 0;
    if (1 < (count = pane.getTabCount())) {
      pane.remove(count - 1);
    }
    pane.addTab("з ", rp);
    pane.setSelectedIndex(1);
  }
  
  public void disposeResult() {
    JTabbedPane pane = getJTabbedPane();
    int count = 0;
    if (1 < (count = pane.getTabCount())) {
      pane.remove(count - 1);
    }
  }

  /**
   * This method initializes taOutput	
   * 	
   * @return javax.swing.JTextArea	
   */
  public JTextArea getTaOutput() {
    if (taOutput == null) {
      taOutput = new JTextArea();
      taOutput.setEditable(false);
    }
    return taOutput;
  }
  
  /**
   * ܼ  ȭ鿡 ϴ ܼ־ƿǲƮ ü Ѵ. 
   * @see ConsoleOutputStream
   * @deprecated 2006-08-26 getTaOutput ޼ҵ带 Ѵ.
   * @return ťƮ ü
   */
  public Document getDocument() {
    return getTaOutput().getDocument();
  }

  /**
   * This method initializes topPanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getTopPanel() {
    if (topPanel == null) {
      topPanel = new JPanel();
      topPanel.setLayout(new BorderLayout());
      topPanel.add(getMenuPanel(), BorderLayout.NORTH);
      topPanel.add(getPathPanel(), java.awt.BorderLayout.SOUTH);
    }
    return topPanel;
  }

  /**
   * This method initializes jScrollPane	
   * 	
   * @return javax.swing.JScrollPane	
   */
  private JScrollPane getJScrollPane() {
    if (jScrollPane == null) {
      jScrollPane = new JScrollPane();
      jScrollPane.setPreferredSize(new Dimension(170, 400));
      jScrollPane.setViewportView(getFileSystemTreePanel());
      getFileSystemTreePanel().getTree().addTreeSelectionListener(this);
      // (new TreeListener((FileListModel)(getFileList().getModel())));
    }
    return jScrollPane;
  }

  /**
   * This method initializes jScrollPane1	
   * 	
   * @return javax.swing.JScrollPane	
   */
  private JScrollPane getJScrollPane1() {
    if (jScrollPane1 == null) {
      jScrollPane1 = new JScrollPane();
      jScrollPane1.setPreferredSize(new Dimension(320, 400));
      jScrollPane1.setViewportView(getFileList());
    }
    return jScrollPane1;
  }

  /**
   * This method initializes pathPanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getPathPanel() {
    if (pathPanel == null) {
      jLabel = new JLabel();
      jLabel.setText(" ġ : ");
      pathPanel = new JPanel();
      pathPanel.add(jLabel, null);
      pathPanel.add(getJTextField(), null);
    }
    return pathPanel;
  }

  /**
   * This method initializes jTextField	
   * 	
   * @return javax.swing.JTextField	
   */
  private JTextField getJTextField() {
    if (jTextField == null) {
      jTextField = new JTextField();
      jTextField.setPreferredSize(new java.awt.Dimension(500,22));
      jTextField.setText("  ʾҽϴ.");
    }
    return jTextField;
  }

  /**
   * This method initializes jContentPane
   * 
   * @return javax.swing.JPanel
   */
  private JPanel getJContentPane() {
    if (jContentPane == null) {
      jContentPane = new JPanel();
      jContentPane.setLayout(new BorderLayout());
      jContentPane.add(getTopPanel(), java.awt.BorderLayout.NORTH);
      jContentPane.add(getSpOutput(), BorderLayout.SOUTH);
      jContentPane.add(getParameterPanel(), BorderLayout.EAST);
      jContentPane.setOpaque(true);
      jContentPane.add(getJTabbedPane(), BorderLayout.CENTER);
    }
    return jContentPane;
  }

	/**
	 * This method initializes spOutput	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getSpOutput() {
		if (spOutput == null) {
			spOutput = new JScrollPane();
			spOutput.setPreferredSize(new Dimension(0, 160));
			spOutput.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			spOutput.setViewportView(getTaOutput());
		}
		return spOutput;
	}
	
  /**
   * This method initializes jSplitPane	
   * 	
   * @return javax.swing.JSplitPane	
   */
  private JSplitPane getJSplitPane() {
    if (jSplitPane == null) {
      jSplitPane = new JSplitPane();
      jSplitPane.setLeftComponent(getJScrollPane());
      jSplitPane.setRightComponent(getJScrollPane1());
    }
    return jSplitPane;
  }

  /**
   * This method initializes fileSystemTreePanel	
   * 	
   * @return net.kldp.cats.ui.FileSystemTreePanel	
   */
  private FileSystemTreePanel getFileSystemTreePanel() {
    if (fileSystemTreePanel == null) {
      FileSystemModel model = new FileSystemModel();
      fileSystemTreePanel = new FileSystemTreePanel(model);
    }
    return fileSystemTreePanel;
  }

  /**
   * This method initializes fileList	
   * 	
   * @return net.kldp.cats.ui.FileList	
   */
  private FileList getFileList() {
    if (fileList == null) {
      fileList = new FileList(new FileListModel());
      fileList.setMain(this);
    }
    return fileList;
  }
  
  /**
   * This method initializes parameterPanel	
   * 	
   * @return net.kldp.cats.ui.ParameterPanel	
   */
  private ParameterPanel getParameterPanel() {
    if (parameterPanel == null) {
      parameterPanel = new ParameterPanel();
      parameterPanel.setPreferredSize(new Dimension(250, 400));
    }
    return parameterPanel;
  }

  /**
   * This method initializes menuPanel	
   * 	
   * @return net.kldp.cats.ui.MenuPanel	
   */
  private MenuPanel getMenuPanel() {
    if (menuPanel == null) {
      menuPanel = new MenuPanel();
      menuPanel.setMain(this);
    }
    return menuPanel;
  }

  /**
   * This method initializes jTabbedPane	
   * 	
   * @return javax.swing.JTabbedPane	
   */
  private JTabbedPane getJTabbedPane() {
    if (jTabbedPane == null) {
      jTabbedPane = new JTabbedPane();
      jTabbedPane.addTab(" Ž", null, getJSplitPane(), null);
    }
    return jTabbedPane;
  }
    
}  //  @jve:decl-index=0:visual-constraint="10,10"
