package net.kldp.cats.ui;

import java.awt.LayoutManager;

import javax.swing.JPanel;
import java.awt.Dimension;
import javax.swing.JTabbedPane;
import java.awt.GridBagConstraints;
import java.awt.BorderLayout;
import java.awt.GridBagLayout;
import java.awt.Rectangle;

import javax.swing.ButtonGroup;
import javax.swing.JFileChooser;
import javax.swing.JRadioButton;
import javax.swing.JLabel;
import javax.swing.BorderFactory;
import java.awt.Color;
import javax.swing.border.TitledBorder;
import java.awt.Font;
import javax.swing.JList;
import javax.swing.ListSelectionModel;
import javax.swing.JComboBox;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.util.Vector;

import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.KeyEvent;
import java.io.File;

/**
 *  з  Ķ͸ ϱ  ׷ ̽
 * 絵
 * 
 * з
 * 
 * ý
 * 
 * @author sjkim
 * @history 2006-08-13 
 * @history 2006-09-03 ǳ(絵, з, ý) 
 */
public class ParameterPanel extends JPanel implements ActionListener {

  private static final long serialVersionUID = 1L;
  private ButtonGroup btngComparision = new ButtonGroup();  //  @jve:decl-index=0:
  private ButtonGroup btngDistance = new ButtonGroup();
  private ButtonGroup btngBand = new ButtonGroup();
  private ButtonGroup btngQuant = new ButtonGroup();
  private ButtonGroup btngGrouping = new ButtonGroup();
  private ButtonGroup btngGroupNum = new ButtonGroup();
  private ButtonGroup btngMoving = new ButtonGroup();
  private JRadioButton[] btnComparisions = null;
  private JRadioButton[] btnDistances = null;
  private JRadioButton[] btnBands = null;
  private JRadioButton[] btnQuants = null;
  private JRadioButton[] btnGroupings = null;
  private JRadioButton[] btnGroupNums = null;

  private JTabbedPane jTabbedPane = null;
  private JPanel jComparisonPanel = null;
  private JPanel jGroupingPanel = null;
  private JPanel jSystemPanel = null;
  private JPanel jFeaturePanel = null;
  private JRadioButton jHistogramRB = null;
  private JRadioButton jCorrelogramRB = null;
  private JPanel jDistancePanel = null;
  private JRadioButton jDistanceRB5 = null;
  private JRadioButton jDistanceRB7 = null;
  private JRadioButton jDistanceRB9 = null;
  private JRadioButton jDistanceRB11 = null;
  private JPanel jBandPanel = null;
  private JRadioButton jBandRB1 = null;
  private JRadioButton jBandRB2 = null;
  private JRadioButton jBandRB4 = null;
  private JPanel jHierarchicalPanel = null;
  private JPanel jPartitionalPanel = null;
  private JPanel jGroupsPanel = null;
  private JRadioButton jSequentialRB = null;
  private JLabel jLabel = null;
  private JRadioButton jShortestRB = null;
  private JRadioButton jLongestRB = null;
  private JRadioButton jMeanRB = null;
  private JPanel jGroupDistancePanel = null;
  private JPanel jQuantizationPanel = null;
  private JRadioButton jQuantRB8 = null;
  private JRadioButton jQuantRB64 = null;
  private JRadioButton jQuantRB512 = null;
  private JRadioButton jKmeansRB = null;
  private JRadioButton jForgyRB = null;
  private JRadioButton jAutoRB = null;
  private JRadioButton jNumberRB = null;
  private JTextField jNumberField = null;
  private JPanel jPanel = null;
  private JTextField jDestinationField = null;
  private JButton jBrowsingBtn = null;
  private JTextField jGroupNameField = null;
  private JFileChooser jFileChooser = null;
  private JRadioButton jCopyRB = null;
  private JRadioButton jMoveRB = null;
  private JPanel jMovingPanel = null;
  private JPanel jDestinationPanel = null;
  private JPanel jGroupNamePanel = null;
  
  public ParameterPanel() {
    super();
    initialize();
    groupingRadioButtons();
  }

  /**
   * This method initializes this
   * 
   * @return void
   */
  private void initialize() {
    this.setSize(250, 360);
    this.setLayout(new BorderLayout());
    this.add(getJTabbedPane(), BorderLayout.CENTER);
  }
  
  private void addParameter(Vector vec, JRadioButton[] btns) {
    for (int i = 0; i < btns.length; i++) {
      if (btns[i].isSelected()) {
        vec.add(btns[i].getName());
        break;
      }
    }
  }
  
  /**
   * Ķ  Ʈ 迭 ȯѴ.
   * .( 5, 7)
   * ġ, 絵 ( ư ),  ȭ  ,
   * (絵   Ÿ    - ÷ ڸα׷   2 ߰)
   * ȼ Ÿ, ,
   * з ( ư ), ׷ 
   * @return parameters
   */
  public String[] getParameters() {
    Vector param = new Vector();
    param.add(getJDestinationField().getText());
    addParameter(param, btnGroupings);
    if (getJNumberRB().isSelected()) {
      param.add(getJNumberField().getText());
    } else {
      param.add("0");
    }
    addParameter(param, btnComparisions);
    addParameter(param, btnQuants);
    if (getJCorrelogramRB().isSelected()) {
      addParameter(param, btnDistances);
      addParameter(param, btnBands);
    }
    
    String[] strs = new String[param.size()];
    for (int i = 0; i < strs.length; i ++) {
      strs[i] = (String) param.get(i);
    }
    return strs;
  } 
  
  public String getGroupName() {
    JTextField tf = getJGroupNameField();
    if (null != tf) {
      return tf.getText();
    } else {
      return "group";
    }
  }
  
  public int getMovingParam() {
    if (getJCopyRB().isSelected()) {
      return ImageMoving.ByCOPY;
    } else {
      return ImageMoving.ByMOVE;
    }
  }
  
  public void actionPerformed(ActionEvent event) {
    if (event.getActionCommand().equals("ã")) {
      File f = null;
      String lists[] = null;
      JFileChooser selector = getJFileChooser();
      JTextField text = getJDestinationField();
      if (JFileChooser.APPROVE_OPTION == selector.showOpenDialog(this)) {
        f = selector.getSelectedFile();
        text.setText(f.getPath());
      } else {
        text.setText(".");
      }
    }
  }
  
  private void groupingRadioButtons() {
    btngComparision.add(getJHistogramRB());
    btngComparision.add(getJCorrelogramRB());
    getJHistogramRB().setSelected(true);
    btngDistance.add(getJDistanceRB5());
    btngDistance.add(getJDistanceRB7());
    btngDistance.add(getJDistanceRB9());
    btngDistance.add(getJDistanceRB11());
    getJDistanceRB7().setSelected(true);
    btngBand.add(getJBandRB1());
    btngBand.add(getJBandRB2());
    btngBand.add(getJBandRB4());
    getJBandRB2().setSelected(true);
    btngQuant.add(getJQuantRB8());
    btngQuant.add(getJQuantRB64());
    btngQuant.add(getJQuantRB512());
    getJQuantRB64().setSelected(true);
    
    btngGrouping.add(getJShortestRB());
    btngGrouping.add(getJLongestRB());
    btngGrouping.add(getJMeanRB());
    btngGrouping.add(getJKmeansRB());
    btngGrouping.add(getJForgyRB());
    btngGrouping.add(getJSequentialRB());
    getJSequentialRB().setSelected(true);
    btngGroupNum.add(getJAutoRB());
    btngGroupNum.add(getJNumberRB());
    getJAutoRB().setSelected(true);
    
    btngMoving.add(getJCopyRB());
    btngMoving.add(getJMoveRB());
    getJCopyRB().setSelected(true);
    
    btnComparisions = new JRadioButton[2];
    btnComparisions[0] = getJHistogramRB();
    btnComparisions[1] = getJCorrelogramRB();
    btnDistances = new JRadioButton[4];
    btnDistances[0] = getJDistanceRB5();
    btnDistances[1] = getJDistanceRB7();
    btnDistances[2] = getJDistanceRB9();
    btnDistances[3] = getJDistanceRB11();
    btnBands = new JRadioButton[3];
    btnBands[0] = getJBandRB1();
    btnBands[1] = getJBandRB2();
    btnBands[2] = getJBandRB4();
    btnQuants = new JRadioButton[3];
    btnQuants[0] = getJQuantRB8();
    btnQuants[1] = getJQuantRB64();
    btnQuants[2] = getJQuantRB512();
    btnGroupings = new JRadioButton[6];
    btnGroupings[0] = getJShortestRB();
    btnGroupings[1] = getJLongestRB();
    btnGroupings[2] = getJMeanRB();
    btnGroupings[3] = getJKmeansRB();
    btnGroupings[4] = getJForgyRB();
    btnGroupings[5] = getJSequentialRB();
    btnGroupNums = new JRadioButton[2];
    btnGroupNums[0] = getJAutoRB();
    btnGroupNums[0] = getJNumberRB();
  }
  
  private void setEnabledComparision(boolean b) {
    getJDistanceRB5().setEnabled(b);
    getJDistanceRB7().setEnabled(b);
    getJDistanceRB9().setEnabled(b);
    getJDistanceRB11().setEnabled(b);
    getJBandRB1().setEnabled(b);
    getJBandRB2().setEnabled(b);
    getJBandRB4().setEnabled(b);
  }

  /**
   * This method initializes jTabbedPane	
   * 	
   * @return javax.swing.JTabbedPane	
   */
  private JTabbedPane getJTabbedPane() {
    if (jTabbedPane == null) {
      jTabbedPane = new JTabbedPane();
      jTabbedPane.addTab("絵", null, getJComparisonPanel(), null);
      jTabbedPane.addTab("з ", null, getJGroupingPanel(), null);
      jTabbedPane.addTab("ý", null, getJSystemPanel(), null);
    }
    return jTabbedPane;
  }

  /**
   * This method initializes jComparisonPanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getJComparisonPanel() {
    if (jComparisonPanel == null) {
      jComparisonPanel = new JPanel();
      jComparisonPanel.setLayout(null);
      jComparisonPanel.add(getJFeaturePanel(), null);
      jComparisonPanel.add(getJQuantizationPanel(), null);
    }
    return jComparisonPanel;
  }

  /**
   * This method initializes jGroupingPanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getJGroupingPanel() {
    if (jGroupingPanel == null) {
      jGroupingPanel = new JPanel();
      jGroupingPanel.setPreferredSize(new Dimension(140, 300));
      jGroupingPanel.setLayout(null);
      jGroupingPanel.add(getJPanel(), null);
      jGroupingPanel.add(getJGroupsPanel(), null);
    }
    return jGroupingPanel;
  }

  /**
   * This method initializes jSystemPanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getJSystemPanel() {
    if (jSystemPanel == null) {
      jSystemPanel = new JPanel();
      jSystemPanel.setLayout(null);
      jSystemPanel.add(getJMovingPanel(), null);
      jSystemPanel.add(getJDestinationPanel(), null);
      jSystemPanel.add(getJGroupNamePanel(), null);
    }
    return jSystemPanel;
  }

  /**
   * This method initializes jFeaturePanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getJFeaturePanel() {
    if (jFeaturePanel == null) {
      jFeaturePanel = new JPanel();
      jFeaturePanel.setLayout(null);
      jFeaturePanel.setBounds(new Rectangle(23, 5, 192, 217));
      jFeaturePanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.gray, 3), "\uc0ac\uc9c4 \ud2b9\uc131", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
      jFeaturePanel.add(getJHistogramRB(), null);
      jFeaturePanel.add(getJCorrelogramRB(), null);
      jFeaturePanel.add(getJDistancePanel(), null);
      jFeaturePanel.add(getJBandPanel(), null);
    }
    return jFeaturePanel;
  }

  /**
   * This method initializes jHistogramRB	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJHistogramRB() {
    if (jHistogramRB == null) {
      jHistogramRB = new JRadioButton();
      jHistogramRB.setBounds(new Rectangle(15, 25, 80, 16));
      jHistogramRB.setName("histo");
      jHistogramRB.setText(" ");
      jHistogramRB.addItemListener(new java.awt.event.ItemListener() {
        public void itemStateChanged(java.awt.event.ItemEvent e) {
          if (ItemEvent.SELECTED == e.getStateChange()) {
            setEnabledComparision(false);
          } else {
            setEnabledComparision(true);
          }
        }
      });
    }
    return jHistogramRB;
  }

  /**
   * This method initializes jCorrelogramRB	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJCorrelogramRB() {
    if (jCorrelogramRB == null) {
      jCorrelogramRB = new JRadioButton();
      jCorrelogramRB.setBounds(new Rectangle(15, 45, 166, 16));
      jCorrelogramRB.setName("cor");
      jCorrelogramRB.setText("Ÿ   ");
    }
    return jCorrelogramRB;
  }

  /**
   * This method initializes jDistancePanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getJDistancePanel() {
    if (jDistancePanel == null) {
      jDistancePanel = new JPanel();
      jDistancePanel.setLayout(null);
      jDistancePanel.setBounds(new Rectangle(38, 70, 122, 76));
      jDistancePanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.gray, 3), "\ud53d\uc140\uac04 \uac70\ub9ac", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
      jDistancePanel.add(getJDistanceRB5(), null);
      jDistancePanel.add(getJDistanceRB7(), null);
      jDistancePanel.add(getJDistanceRB9(), null);
      jDistancePanel.add(getJDistanceRB11(), null);
    }
    return jDistancePanel;
  }

  /**
   * This method initializes jDistanceRB5	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJDistanceRB5() {
    if (jDistanceRB5 == null) {
      jDistanceRB5 = new JRadioButton();
      jDistanceRB5.setText("5");
      jDistanceRB5.setName("5");
      jDistanceRB5.setBounds(new Rectangle(16, 20, 32, 26));
    }
    return jDistanceRB5;
  }

  /**
   * This method initializes jDistanceRB7	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJDistanceRB7() {
    if (jDistanceRB7 == null) {
      jDistanceRB7 = new JRadioButton();
      jDistanceRB7.setText("7");
      jDistanceRB7.setName("7");
      jDistanceRB7.setBounds(new Rectangle(55, 21, 32, 26));
    }
    return jDistanceRB7;
  }

  /**
   * This method initializes jDistanceRB9	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJDistanceRB9() {
    if (jDistanceRB9 == null) {
      jDistanceRB9 = new JRadioButton();
      jDistanceRB9.setText("9");
      jDistanceRB9.setName("9");
      jDistanceRB9.setBounds(new Rectangle(16, 44, 32, 26));
    }
    return jDistanceRB9;
  }

  /**
   * This method initializes jDistanceRB11	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJDistanceRB11() {
    if (jDistanceRB11 == null) {
      jDistanceRB11 = new JRadioButton();
      jDistanceRB11.setText("11");
      jDistanceRB11.setName("11");
      jDistanceRB11.setBounds(new Rectangle(55, 44, 39, 26));
    }
    return jDistanceRB11;
  }

  /**
   * This method initializes jBandPanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getJBandPanel() {
    if (jBandPanel == null) {
      jBandPanel = new JPanel();
      jBandPanel.setLayout(new BorderLayout());
      jBandPanel.setBounds(new Rectangle(40, 149, 116, 55));
      jBandPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.gray, 3), "\ubc34\ub4dc", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
      jBandPanel.add(getJBandRB1(), BorderLayout.WEST);
      jBandPanel.add(getJBandRB2(), BorderLayout.CENTER);
      jBandPanel.add(getJBandRB4(), BorderLayout.EAST);
    }
    return jBandPanel;
  }

  /**
   * This method initializes jBandRB1	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJBandRB1() {
    if (jBandRB1 == null) {
      jBandRB1 = new JRadioButton();
      jBandRB1.setText("1");
      jBandRB1.setName("1");
    }
    return jBandRB1;
  }

  /**
   * This method initializes jBandRB2	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJBandRB2() {
    if (jBandRB2 == null) {
      jBandRB2 = new JRadioButton();
      jBandRB2.setText("2");
      jBandRB2.setName("2");
    }
    return jBandRB2;
  }

  /**
   * This method initializes jBandRB3	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJBandRB4() {
    if (jBandRB4 == null) {
      jBandRB4 = new JRadioButton();
      jBandRB4.setText("4");
      jBandRB4.setName("4");
    }
    return jBandRB4;
  }

  /**
   * This method initializes jHierarchicalPanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getJHierarchicalPanel() {
    if (jHierarchicalPanel == null) {
      jLabel = new JLabel();
      jLabel.setText("      ׷찣 絵");
      jHierarchicalPanel = new JPanel();
      jHierarchicalPanel.setBounds(new Rectangle(10, 12, 187, 84));
      jHierarchicalPanel.setLayout(new BorderLayout());
      jHierarchicalPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.gray, 3), "\ubcd1\ud569\uc2dd", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
      jHierarchicalPanel.add(jLabel, BorderLayout.NORTH);
      jHierarchicalPanel.add(getJGroupDistancePanel(), BorderLayout.CENTER);
    }
    return jHierarchicalPanel;
  }

  /**
   * This method initializes jPartitionalPanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getJPartitionalPanel() {
    if (jPartitionalPanel == null) {
      GridLayout gridLayout1 = new GridLayout();
      gridLayout1.setRows(1);
      jPartitionalPanel = new JPanel();
      jPartitionalPanel.setBounds(new Rectangle(10, 102, 168, 56));
      jPartitionalPanel.setLayout(gridLayout1);
      jPartitionalPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.gray, 3), "\ubd84\ud560\uc2dd", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
      jPartitionalPanel.add(getJKmeansRB(), null);
      jPartitionalPanel.add(getJForgyRB(), null);
    }
    return jPartitionalPanel;
  }

  /**
   * This method initializes jGroupsPanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getJGroupsPanel() {
    if (jGroupsPanel == null) {
      GridBagConstraints gridBagConstraints = new GridBagConstraints();
      gridBagConstraints.gridx = 0;
      gridBagConstraints.gridy = 0;
      jGroupsPanel = new JPanel();
      jGroupsPanel.setLayout(null);
      jGroupsPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.gray, 3), "\uadf8\ub8f9 \uac1c\uc218", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
      jGroupsPanel.setBounds(new Rectangle(18, 214, 200, 89));
      jGroupsPanel.add(getJAutoRB(), null);
      jGroupsPanel.add(getJNumberRB(), null);
      jGroupsPanel.add(getJNumberField(), null);
    }
    return jGroupsPanel;
  }

  /**
   * This method initializes jSequentialRB	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJSequentialRB() {
    if (jSequentialRB == null) {
      jSequentialRB = new JRadioButton();
      jSequentialRB.setText("  з ");
      jSequentialRB.setName("seq");
      jSequentialRB.setBounds(new Rectangle(10, 163, 151, 26));
    }
    return jSequentialRB;
  }

  /**
   * This method initializes jShortestRB	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJShortestRB() {
    if (jShortestRB == null) {
      jShortestRB = new JRadioButton();
      jShortestRB.setText("ּ");
      jShortestRB.setName("hrShort");
    }
    return jShortestRB;
  }

  /**
   * This method initializes jLongestRB	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJLongestRB() {
    if (jLongestRB == null) {
      jLongestRB = new JRadioButton();
      jLongestRB.setText("ִ");
      jLongestRB.setName("hrLong");
    }
    return jLongestRB;
  }

  /**
   * This method initializes jMeanRB	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJMeanRB() {
    if (jMeanRB == null) {
      jMeanRB = new JRadioButton();
      jMeanRB.setText("");
      jMeanRB.setName("hrMean");
    }
    return jMeanRB;
  }

  /**
   * This method initializes jGroupDistancePanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getJGroupDistancePanel() {
    if (jGroupDistancePanel == null) {
      jGroupDistancePanel = new JPanel();
      jGroupDistancePanel.setLayout(new FlowLayout());
      jGroupDistancePanel.add(getJShortestRB(), null);
      jGroupDistancePanel.add(getJLongestRB(), null);
      jGroupDistancePanel.add(getJMeanRB(), null);
    }
    return jGroupDistancePanel;
  }

  /**
   * This method initializes jQuantizationPanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getJQuantizationPanel() {
    if (jQuantizationPanel == null) {
      jQuantizationPanel = new JPanel();
      jQuantizationPanel.setLayout(null);
      jQuantizationPanel.setBounds(new Rectangle(25, 228, 185, 64));
      jQuantizationPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.gray, 3), "\uc0c9\uae54 \uac1c\uc218", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
      jQuantizationPanel.add(getJQuantRB8(), null);
      jQuantizationPanel.add(getJQuantRB64(), null);
      jQuantizationPanel.add(getJQuantRB512(), null);
    }
    return jQuantizationPanel;
  }

  /**
   * This method initializes jQuantRB8	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJQuantRB8() {
    if (jQuantRB8 == null) {
      jQuantRB8 = new JRadioButton();
      jQuantRB8.setBounds(new Rectangle(14, 25, 47, 21));
      jQuantRB8.setName("8");
      jQuantRB8.setText("8");
    }
    return jQuantRB8;
  }

  /**
   * This method initializes jQuantRB64	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJQuantRB64() {
    if (jQuantRB64 == null) {
      jQuantRB64 = new JRadioButton();
      jQuantRB64.setBounds(new Rectangle(58, 25, 47, 21));
      jQuantRB64.setName("64");
      jQuantRB64.setText("64");
    }
    return jQuantRB64;
  }

  /**
   * This method initializes jQuantRB512	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJQuantRB512() {
    if (jQuantRB512 == null) {
      jQuantRB512 = new JRadioButton();
      jQuantRB512.setBounds(new Rectangle(113, 25, 47, 21));
      jQuantRB512.setName("512");
      jQuantRB512.setText("512");
    }
    return jQuantRB512;
  }

  /**
   * This method initializes jKmeansRB	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJKmeansRB() {
    if (jKmeansRB == null) {
      jKmeansRB = new JRadioButton();
      jKmeansRB.setText("̹");
      jKmeansRB.setName("ptKmeans");
    }
    return jKmeansRB;
  }

  /**
   * This method initializes jForgyRB	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJForgyRB() {
    if (jForgyRB == null) {
      jForgyRB = new JRadioButton();
      jForgyRB.setText("");
      jForgyRB.setName("ptForgy");
    }
    return jForgyRB;
  }

  /**
   * This method initializes jAutoRB	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJAutoRB() {
    if (jAutoRB == null) {
      jAutoRB = new JRadioButton();
      jAutoRB.setText("ڵ");
      jAutoRB.setBounds(new Rectangle(28, 26, 51, 26));
    }
    return jAutoRB;
  }

  /**
   * This method initializes jNumberRB	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJNumberRB() {
    if (jNumberRB == null) {
      jNumberRB = new JRadioButton();
      jNumberRB.setText("");
      jNumberRB.setBounds(new Rectangle(28, 52, 51, 26));
    }
    return jNumberRB;
  }

  /**
   * This method initializes jNumberField	
   * 	
   * @return javax.swing.JTextField	
   */
  private JTextField getJNumberField() {
    if (jNumberField == null) {
      jNumberField = new JTextField();
      jNumberField.setPreferredSize(new Dimension(40, 22));
      jNumberField.setBounds(new Rectangle(93, 52, 40, 22));
    }
    return jNumberField;
  }

  /**
   * This method initializes jPanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getJPanel() {
    if (jPanel == null) {
      jPanel = new JPanel();
      jPanel.setLayout(null);
      jPanel.setBounds(new Rectangle(17, 8, 204, 196));
      jPanel.setBorder(BorderFactory.createLineBorder(Color.gray, 3));
      jPanel.add(getJHierarchicalPanel(), null);
      jPanel.add(getJPartitionalPanel(), null);
      jPanel.add(getJSequentialRB(), null);
    }
    return jPanel;
  }

  /**
   * This method initializes jDestinationField	
   * 	
   * @return javax.swing.JTextField	
   */
  private JTextField getJDestinationField() {
    if (jDestinationField == null) {
      jDestinationField = new JTextField();
      jDestinationField.setText(".");
      jDestinationField.setPreferredSize(new Dimension(190, 22));
    }
    return jDestinationField;
  }

  /**
   * This method initializes jBrowsingBtn	
   * 	
   * @return javax.swing.JButton	
   */
  private JButton getJBrowsingBtn() {
    if (jBrowsingBtn == null) {
      jBrowsingBtn = new JButton();
      jBrowsingBtn.setText("ã");
      jBrowsingBtn.addActionListener(this);
    }
    return jBrowsingBtn;
  }

  /**
   * This method initializes jGroupNameField	
   * 	
   * @return javax.swing.JTextField	
   */
  private JTextField getJGroupNameField() {
    if (jGroupNameField == null) {
      jGroupNameField = new JTextField();
      jGroupNameField.setText("group");
      jGroupNameField.setPreferredSize(new Dimension(180, 22));
    }
    return jGroupNameField;
  }

  /**
   * This method initializes jFileChooser	
   * 	
   * @return javax.swing.JFileChooser	
   */
  private JFileChooser getJFileChooser() {
    if (jFileChooser == null) {
      jFileChooser = new JFileChooser(System.getProperty("user.dir"));
      jFileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

    }
    return jFileChooser;
  }

  /**
   * This method initializes jCopyRB	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJCopyRB() {
    if (jCopyRB == null) {
      jCopyRB = new JRadioButton();
      jCopyRB.setText("");
    }
    return jCopyRB;
  }

  /**
   * This method initializes jMoveRB	
   * 	
   * @return javax.swing.JRadioButton	
   */
  private JRadioButton getJMoveRB() {
    if (jMoveRB == null) {
      jMoveRB = new JRadioButton();
      jMoveRB.setText("̵");
    }
    return jMoveRB;
  }

  /**
   * This method initializes jMovingPanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getJMovingPanel() {
    if (jMovingPanel == null) {
      jMovingPanel = new JPanel();
      jMovingPanel.setLayout(new FlowLayout());
      jMovingPanel.setBounds(new Rectangle(18, 217, 162, 61));
      jMovingPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.gray, 3), "\uc0ac\uc9c4 \uc62e\uae30\uae30", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
      jMovingPanel.add(getJCopyRB(), null);
      jMovingPanel.add(getJMoveRB(), null);
    }
    return jMovingPanel;
  }

  /**
   * This method initializes jDestinationPanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getJDestinationPanel() {
    if (jDestinationPanel == null) {
      jDestinationPanel = new JPanel();
      jDestinationPanel.setLayout(new FlowLayout());
      jDestinationPanel.setBounds(new Rectangle(18, 22, 213, 98));
      jDestinationPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.gray, 3), "\uc800\uc7a5\uc704\uce58", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
      jDestinationPanel.add(getJDestinationField(), null);
      jDestinationPanel.add(getJBrowsingBtn(), null);
    }
    return jDestinationPanel;
  }

  /**
   * This method initializes jGroupNamePanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getJGroupNamePanel() {
    if (jGroupNamePanel == null) {
      jGroupNamePanel = new JPanel();
      jGroupNamePanel.setLayout(new FlowLayout());
      jGroupNamePanel.setBounds(new Rectangle(18, 140, 200, 64));
      jGroupNamePanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.gray, 3), "\uadf8\ub8f9 \uc774\ub984", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
      jGroupNamePanel.add(getJGroupNameField(), null);
    }
    return jGroupNamePanel;
  }

}
