package net.kldp.cats.ui;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ProgressMonitor;
import javax.swing.Timer;

/**
 * ð  ɸ ۾ ¸ ȭ鿡 ش.
 * .
 * final LongTask task = ...;
 * SwingUtilities.invokeLater(new Runnable() {
 *   public void run() {
 *     ProgressDisplay progressDisplay =
 *       new ProgressDisplay("۾ ", task);
 *     progressDisplay.show(); 
 *   }
 * });
 * ǻ.
 * ݵ  ؾ ȭ鿡 Ÿ. 
 * @see LongTask
 * 
 * @author sjkim
 * @history 2006-08-27 
 * @history 2006-09-01   
 */
public class ProgressDisplay {

  private Timer timer = null;
  private LongTask task = null;
  private ProgressMonitor progressMonitor = null;
  
  public ProgressDisplay(Component comp, String message, LongTask task) {
    this.task = task;
    progressMonitor = new ProgressMonitor(comp, message,
        "", 0, task.getLengthOfTask());
    timer = new Timer(1000, new TimerListener());
  }
  
  public void show() {
    progressMonitor.setProgress(0);
    progressMonitor.setMillisToDecideToPopup(1000);
    timer.start();
  }

  protected class TimerListener implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      progressMonitor.setProgress(task.getCurrent());
      progressMonitor.setNote(task.getMessage());
      if (progressMonitor.isCanceled() || task.isDone()) {
        progressMonitor.close();
        timer.stop();
      }
    }
  }  
}
