package net.kldp.cats.ui.ResultViewer;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;

import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;

import net.kldp.cats.ui.MainFrame;
import net.kldp.cats.ui.ThumbsDB;

/**
 *  з   ִ Ŭ
 * ǻ.
 *  Ŭ ü   ݵ ̾ƿ ÷ο췹̾ƿ ٲ Ѵ.
 * ׷        ִ.
 * @see PictureList
 * @author sjkim
 * @history 2006-09-07  
 */
public class PictureGroupPanel extends JPanel {

  protected MainFrame main = null;
  protected String[] fileList = null;
  protected int[][] groupList = null;
  protected JPanel[] picturesPanel = null;
  protected PictureList[] pictureList = null;
  protected ThumbsDB thumbsDB = null;
  protected DoubleClick doubleClick = new DoubleClick();
  
  protected class DoubleClick implements MouseListener {
    public void mouseClicked(MouseEvent e) {
      if (2 <= e.getClickCount()) {
        JList list = (JList)e.getSource();
        if (null != main) {
          main.showImage(new File((String)list.getSelectedValue()));
        }
      }
    }
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
  }

  public PictureGroupPanel() {
    super();
    init();
  }

  public PictureGroupPanel(MainFrame frame,
      String listFilename, String groupListFilename,
      ThumbsDB thumbs) {
    super();
    try {
      main = frame;
      fileList = readFileList(listFilename);
      groupList = readGroupList(groupListFilename);
      thumbsDB = thumbs;
      init();
      constructLists();
    } catch (IOException e) {
      e.printStackTrace();
    }
  }
  
  private void init() {
    setLayout(new GridLayout(0, 1));
  }
  
  /**
   *  ׷ ̸ ִ ׷ Ʈ
   *  ׷쿡   ִ  Ʈ 
   * .
   */
  public void constructLists() {
    PictureListModel model;
    picturesPanel = new JPanel[groupList.length];
    pictureList = new PictureList[groupList.length];
    for (int i = 0; i < groupList.length; i++) {
      model = new PictureListModel();
      model.setList(getPictureGroupList(i));
      pictureList[i] = new PictureList(model, thumbsDB);
      pictureList[i].addMouseListener(doubleClick);
      picturesPanel[i] = new JPanel(new BorderLayout());
      picturesPanel[i].add(new JLabel("        ׷ " + i + " "), 
                           BorderLayout.NORTH);
      picturesPanel[i].add(pictureList[i], BorderLayout.CENTER);
      add(picturesPanel[i]);
    }
  }
  
  /**
   *  ׷쿡    ̸ ´.
   * @param index ׷ ȣ
   * @return
   */
  protected String[] getPictureGroupList(int index) {
    if (index < 0) {
      return null; 
    } else {
      String[] list = new String[groupList[index].length];
      for (int i = 0; i < list.length; i++) {
        list[i] = fileList[groupList[index][i]];
      }
      return list;
    }
  }

  /**
   * ()ϸƮ д´.
   * @param fname ()ϸƮ()
   * @return  ̸ Ʈ 迭
   * @throws IOException   Ͽ.
   */    
  public String[] readFileList(String fname) throws IOException {
    String[] list = null;
    if (null != fname) {
      FileReader fr = new FileReader(fname);
      BufferedReader br = new BufferedReader(fr);
      String aLine = null;
      int idx = 1, size;
      aLine = br.readLine();
      size = Integer.parseInt(aLine);
      list = new String[size+1];
      while (null != (aLine=br.readLine())) {
        list[idx++] = aLine;
      }    
      br.close();
      fr.close();
    }
    return list;
  }
  
  /**
   * з  (׷츮Ʈ) д´.
   * @param fname ׷츮Ʈ()
   * @throws IOException   Ͽ.
   */
  public int[][] readGroupList(String fname) throws IOException {
    int[][] groupList = null;
    if (null != fname) {
      FileReader fr = new FileReader(fname);
      BufferedReader br = new BufferedReader(fr);
      String aLine = null;
      int size, group;
      StringTokenizer st = null;
      aLine = br.readLine();
      size = Integer.parseInt(aLine);
      groupList = new int[size][];
      group = 0;
      while (null != (aLine=br.readLine())) {
        st = new StringTokenizer(aLine);
        if (st.hasMoreTokens()) {
          groupList[group] = new int[st.countTokens()];
        }
        int i = 0;
        while (st.hasMoreTokens()) {
          groupList[group][i++] = Integer.parseInt(st.nextToken());
        }
        group++;
      }    
      br.close();
      fr.close();
    }
    return groupList;
  }
}
