package net.kldp.cats.ui.ResultViewer;

import javax.swing.JPanel;
import java.awt.FlowLayout;
import javax.swing.JScrollPane;

import net.kldp.cats.ui.ImageMoving;
import net.kldp.cats.ui.LongTask;
import net.kldp.cats.ui.MainFrame;
import net.kldp.cats.ui.ProgressDisplay;
import net.kldp.cats.ui.ThumbsDB;

import java.awt.Dimension;
import java.io.File;
import java.io.IOException;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.GridLayout;

import javax.swing.JButton;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;

import javax.swing.JList;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;
import javax.swing.JCheckBox;

/**
 *  з  ȭ鿡 ִ Ŭ
 * 
 * @see MainFrame, PictureGroupPanel
 * @author sjkim
 * @history 2006-09-01 
 * @history 2006-09-03  ׷ ̸ ϸ ׷쿡   ش.
 * @history 2006-09-07 з  Ѳ  ش.
 * ׷ Ʈ ׷츮Ʈ ü  ʰ
 * ĸƮ ϴ ı׷ǳ  .
 * @history 2006-09-08 ιθ ũϵ 
 * з  ִ ı׷ǳ   ׸ ̾ƿ  
 * ȭ鿡   ÷ο췹̾ƿ ߴ. 
 */
public class ResultPanel extends JPanel
                         implements ActionListener,
                                    ComponentListener {

  private static final long serialVersionUID = 1L;
  private MainFrame main = null;
  private PictureList pictureList = null;
  private PictureGroupPanel pictureGroupPanel = null;
  private JScrollPane jScrollPane1 = null;
  private JPanel jPanel = null;
  private JButton jConfirmBtn = null;
  private JLabel jLabel = null;

  /**
   * This is the default constructor
   */
  public ResultPanel(MainFrame main) {
    super();
    this.main = main;
    initialize();
    constructLists();
  }

  /**
   * This method initializes this
   * 
   * @return void
   */
  private void initialize() {
    this.setSize(400, 420);
    this.setLayout(new BorderLayout());
    this.add(getJPanel(), BorderLayout.NORTH);
    this.add(getJScrollPane1(), BorderLayout.CENTER);
    this.addComponentListener(this);
  }
  
  /**
   *  ׷ ̸ ִ ׷ Ʈ
   *  ׷쿡   ִ  Ʈ 
   * .
   */
  public void constructLists() {
    String[] args = main.getArguments();
    File f = new File(args[0]);
    String lstFile = f.getName() + ".lst";
    String grpFile = f.getName() + "-" + args[2] + "-" + args[4] + ".grp";
    ThumbsDB thumbs = ThumbsDB.createDB(f);

    pictureGroupPanel = new PictureGroupPanel(main,
        lstFile, grpFile, thumbs);
    getJScrollPane1().setViewportView(pictureGroupPanel);
  }
    
  protected void showPicture(String[] fileList, int[] group) {
    String[] list = new String[group.length];
    for (int i = 0; i < list.length; i++) {
      list[i] = fileList[group[i]];
    }
    ((PictureListModel)pictureList.getModel()).setList(list);
  }

  public void actionPerformed(ActionEvent event) {
    if (event.getSource().equals(getJConfirmBtn())) {
      System.out.println(" /̵");
      ImageMoving imageMoving = new ImageMoving(main);
      String[] args = main.getArguments();
      File f = new File(args[0]);
      for (int i = 0; i < args.length; i++) {
        System.out.println(i + ", " + args[i]);
      }
      String lstFile = f.getName() + ".lst";
      String grpFile = f.getName() + "-" + args[2] + "-" + args[4] + ".grp";
      final LongTask task = (LongTask) imageMoving;
      final Component comp = main;
      SwingUtilities.invokeLater(new Runnable(){
        public void run() {
          ProgressDisplay progressDisplay =
            new ProgressDisplay(comp, "׷  űϴ. " +
                "ø ٷ ּ.", task);
          progressDisplay.show(); 
        }
      });
      try {
        imageMoving.readFileList(lstFile);
        imageMoving.readGroupList(grpFile);
        imageMoving.move(args[1], main.getMovingParam());
      } catch (IOException e) {
        System.out.println(" /̵   ߽ϴ.");
        e.printStackTrace();
      }
      main.disposeResult();
    }
  }
  
  public void componentHidden(ComponentEvent e) {}
  
  public void componentMoved(ComponentEvent e) {}
  
  public void componentResized(ComponentEvent e) {
    Component[] comps = pictureGroupPanel.getComponents();
    Dimension dimension = e.getComponent().getSize();
    Dimension cellDimension;
    JList jList;
    JLabel jLabel;
    int cellWidth, cellHeight, tagHeight;
    int width, height, size;
    int totalHeight = 20;
    width = dimension.width - 18;
    if (null != comps) {
      jLabel = (JLabel) ((JPanel) comps[0]).getComponent(0);
      tagHeight = jLabel.getHeight();
      jList = (JList) ((JPanel) comps[0]).getComponent(1);
      cellDimension = ((JLabel) jList.getCellRenderer())
                      .getPreferredSize();
      cellWidth = cellDimension.width;
      cellHeight = cellDimension.height;
      for (int i = 0; i < comps.length; i++) {
        jList = (JList) ((JPanel) comps[i]).getComponent(1);
        size = jList.getModel().getSize();
        height = tagHeight + 
                 cellHeight * (1 + cellWidth * size / width);
        totalHeight += height + 5;
        comps[i].setPreferredSize(new Dimension(width, height));
      }
    }
    pictureGroupPanel.setPreferredSize(new Dimension(width, totalHeight));
    if (pictureGroupPanel.getLayout() instanceof GridLayout) {
      pictureGroupPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    }
  }
  
  public void componentShown(ComponentEvent e) {}

  /**
   * This method initializes jScrollPane1	
   * 	
   * @return javax.swing.JScrollPane	
   */
  private JScrollPane getJScrollPane1() {
    if (jScrollPane1 == null) {
      jScrollPane1 = new JScrollPane();
    }
    return jScrollPane1;
  }

  /**
   * This method initializes jPanel	
   * 	
   * @return javax.swing.JPanel	
   */
  private JPanel getJPanel() {
    if (jPanel == null) {
      jLabel = new JLabel();
      jLabel.setText("Ȯ  /̵ մϴ.");
      jPanel = new JPanel();
      jPanel.setLayout(new FlowLayout());
      jPanel.add(jLabel, null);
      jPanel.add(getJConfirmBtn(), null);
    }
    return jPanel;
  }

  /**
   * This method initializes jConfirmBtn	
   * 	
   * @return javax.swing.JButton	
   */
  private JButton getJConfirmBtn() {
    if (jConfirmBtn == null) {
      jConfirmBtn = new JButton();
      jConfirmBtn.setText("Ȯ");
      jConfirmBtn.addActionListener(this);
    }
    return jConfirmBtn;
  }
}
