package net.kldp.cats.ui;

import java.awt.Image;
import java.awt.image.ImageFilter;
import java.io.File;
import java.io.FileFilter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.MalformedURLException;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.swing.ImageIcon;

/**
 * ̸  ̽  ϴ Ŭ
 * 
 * .
 * ThumbsDB db = ThumbsDB.createDB(new File("丮 "));
 * ImageIcon ic = db.getIcon("׸ ̸.jpg");
 * 
 * .
 * ̸  N ()
 * ̸ 1 (ڿ)
 * ̸ 1 (̹)
 * ̸ 2 (ڿ)
 * ̸ 2 (̹)
 * ...
 * ̸ N (ڿ)
 * ̸ N (̹)
 * 
 * ǻ.
 * @author sjkim
 * @history 2006-08-27 
 * @history 2006-09-01 creatDB ޼ҵ忡 ̹ 
 * ׸  Ȯڰ 빮  ̸Ⱑ ȵǼ ̹͸ 
 */
public class ThumbsDB {
  public static final String FILENAME = ".thumbs";
  public static final FileFilter Filter = new ImageFileFilter();
  
  protected File directory;
  protected Hashtable hash;
  protected int numOfThumbs;

  /**
   * ThumbsDB ü ݵ createDB ޼ҵ带 ؼ Ѵ.
   */
  private ThumbsDB() {}
  
  /**
   * ̸ ͺ̽ Ͽ ش ׸  ̸  ´.
   * @param fname ׸ ̸
   * @return ̹ 
   */
  public ImageIcon getIcon(String fname) {
    return (ImageIcon) hash.get(fname);
  }
  
  /**
   * ش 丮 ο ̸ ͺ̽  аų  .
   * @param directory 丮 
   * @return ̸ ͺ̽
   * @history 2006-09-01 ̹ 
   */
  public static synchronized ThumbsDB createDB(File directory) {
    File thumbFile = new File(directory, ThumbsDB.FILENAME);
    ThumbsDB db = new ThumbsDB();
    if (thumbFile.exists() &&
        thumbFile.lastModified() >= directory.lastModified()) {
      System.out.println("load");
      db.load(directory);
    } else {
      System.out.println("create");
      db.directory = directory;
      db.hash = new Hashtable();
      db.numOfThumbs = 0;
      File[] list = directory.listFiles(ThumbsDB.Filter);
      String name;
      Image im;
      for (int i = 0; i < list.length; i++) {
        name = list[i].getName();
        im = ThumbsDB.createThumb(list[i]);
        if (null != im) {
          db.hash.put(list[i].getName(), new ImageIcon(im));
          db.numOfThumbs++;
        }
      }
      db.write();
    }
    return db;
  }
  
  /**
   * 丮 ο ִ ̸ ͺ̽  д´.
   * @param directory 丮 
   */
  public void load(File directory) {
    this.directory = directory;
    this.hash = new Hashtable();
    try {
      FileInputStream fis =
        new FileInputStream(new File(directory, ThumbsDB.FILENAME));
      ObjectInputStream ois = new ObjectInputStream(fis);
      numOfThumbs = ois.readInt();
      for (int i = 0; i < numOfThumbs; i++) {
        hash.put(ois.readObject(), ois.readObject());
      }
      ois.close();
      fis.close();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
    
  /**
   * ׸ о ̸ ̹ .
   * @param file ׸ 
   * @return ̸ ̹
   */
  public static Image createThumb(File file) {
    ImageIcon ic = null;
    Image im = null;
    try {
      ic = new ImageIcon(file.toURL());
    } catch (MalformedURLException e) {
      e.printStackTrace();
    }
    if (null != ic) {
      im = ic.getImage();
      return im.getScaledInstance(60, 60, Image.SCALE_FAST);
    } else {
      return null;
    }
  }
  
  /**
   * ̸ ͺ̽ Ϸ Ѵ.
   */
  protected synchronized void write() {
    try {
      File file = new File(directory, ThumbsDB.FILENAME);
      FileOutputStream fos = new FileOutputStream(file);
      ObjectOutputStream oos = new ObjectOutputStream(fos);
      Enumeration en = hash.keys();
      String fname;
      oos.writeInt(numOfThumbs);
      while (en.hasMoreElements()) {
        fname = (String) en.nextElement();
        oos.writeObject(fname);
        oos.writeObject(hash.get(fname));
      }
      
      oos.close();
      fos.close();
    } catch (IOException e) {
      e.printStackTrace();
    }
  }
  
  /**
   * ̸ ͺ̽   ȭ鿡 Ѵ.
   */
  public void show() {
    Enumeration en = hash.keys();
    String fname;
    while (en.hasMoreElements()) {
      fname = (String) en.nextElement();
      System.out.println(fname);
      System.out.println(hash.get(fname));
    }
  }
}
